datablock ParticleData(SMASHBoundProjectileExplosionParticle1_Green)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 600;
   lifetimeVarianceMS   = 000;
   textureName          = "special/crescent4";
   colors[0] = "0.1 1.0 0.1 1.0";
   colors[1] = "0.1 1.0 0.1 1.0";
   colors[2] = "0.1 1.0 0.1 0.0";
   sizes[0]      = 0.25 * 8;
   sizes[1]      = 0.5 * 8;
   sizes[2]      = 1.0 * 8;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(SMASHBoundProjectileExplosionEmitter1_Green)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.5;
   ejectionOffset   = 0.0;
   thetaMin         = 70;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 200;
   particles = "SMASHBoundProjectileExplosionParticle1_Green";
};

datablock ParticleData(SMASHBoundProjectileExplosionParticle2_Green)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 600;
   lifetimeVarianceMS   = 000;
   textureName          = "special/blasterHit";
   colors[0] = "0.1 1.0 0.1 1.0";
   colors[1] = "0.1 1.0 0.1 0.5";
   colors[2] = "0.1 1.0 0.1 0.0";
   sizes[0]      = 0.3 * 8;
   sizes[1]      = 0.90 * 8;
   sizes[2]      = 1.50 * 8;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(SMASHBoundProjectileExplosionEmitter2_Green)
{
   ejectionPeriodMS = 30;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = false;
   lifetimeMS       = 200;
   particles = "SMASHBoundProjectileExplosionParticle2_Green";
};

datablock ExplosionData(SMASHBoundProjectileExplosion_Green)
{
   soundProfile   = PlasmaBarrelExpSound;
   emitter[0]     = SMASHBoundProjectileExplosionEmitter1_Green;
   emitter[1]     = SMASHBoundProjectileExplosionEmitter2_Green;
};

datablock LinearFlareProjectileData(SMASHBoundProjectile_Green)
{
   directDamage        = 0;
   directDamageType    = $DamageType::Default;
   hasDamageRadius     = false;
   indirectDamage      = 0.0;
   damageRadius        = 0.0;
   kickBackStrength    = 0;
   radiusDamageType    = $DamageType::Default;
   explosion           = SMASHBoundProjectileExplosion_Green;
   splash              = PlasmaSplash;

   dryVelocity       = 50.0;
   wetVelocity       = 50.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 900;
   lifetimeMS        = 1000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = -1;

   activateDelayMS = -1;

   scale             = "1 1 1";
   numFlares         = 30;
   flareColor        = "0.1 1.0 0.1";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "0.1 1.0 0.1";
};
datablock ParticleData(SMASHBoundProjectileExplosionParticle1_Yellow) : SMASHBoundProjectileExplosionParticle1_Green
{
   colors[0] = "1.0 0.75 0.1 1.0";
   colors[1] = "1.0 0.75 0.1 1.0";
   colors[2] = "1.0 0.75 0.1 0.0";
};

datablock ParticleEmitterData(SMASHBoundProjectileExplosionEmitter1_Yellow) : SMASHBoundProjectileExplosionEmitter1_Green
{
   particles = "SMASHBoundProjectileExplosionParticle1_Yellow";
};

datablock ParticleData(SMASHBoundProjectileExplosionParticle2_Yellow) : SMASHBoundProjectileExplosionParticle2_Green
{
   colors[0] = "1.0 0.75 0.1 1.0";
   colors[1] = "1.0 0.75 0.1 0.5";
   colors[2] = "1.0 0.75 0.1 0.0";
};

datablock ParticleEmitterData(SMASHBoundProjectileExplosionEmitter2_Yellow) : SMASHBoundProjectileExplosionEmitter2_Green
{
   particles = "SMASHBoundProjectileExplosionParticle2_Yellow";
};

datablock ExplosionData(SMASHBoundProjectileExplosion_Yellow) : SMASHBoundProjectileExplosion_Green
{
   emitter[0]     = SMASHBoundProjectileExplosionEmitter1_Yellow;
   emitter[1]     = SMASHBoundProjectileExplosionEmitter2_Yellow;
};

datablock LinearFlareProjectileData(SMASHBoundProjectile_Yellow) : SMASHBoundProjectile_Green
{
   explosion           = SMASHBoundProjectileExplosion_Yellow;
   flareColor        = "1.0 0.75 0.1";
   lightColor  = "1.0 0.75 0.1";
};
datablock ParticleData(SMASHBoundProjectileExplosionParticle1_Red) : SMASHBoundProjectileExplosionParticle1_Green
{
   colors[0] = "1.0 0.8 0.2 1.0";
   colors[1] = "1.0 0.4 0.2 1.0";
   colors[2] = "1.0 0.0 0.0 0.0";
};

datablock ParticleEmitterData(SMASHBoundProjectileExplosionEmitter1_Red) : SMASHBoundProjectileExplosionEmitter1_Green
{
   particles = "SMASHBoundProjectileExplosionParticle1_Red";
};

datablock ParticleData(SMASHBoundProjectileExplosionParticle2_Red) : SMASHBoundProjectileExplosionParticle2_Green
{
   colors[0] = "1.0 0.2 0.2 1.0";
   colors[1] = "1.0 0.2 0.2 0.5";
   colors[2] = "1.0 0.0 0.0 0.0";
};

datablock ParticleEmitterData(SMASHBoundProjectileExplosionEmitter2_Red) : SMASHBoundProjectileExplosionEmitter2_Green
{
   particles = "SMASHBoundProjectileExplosionParticle2_Red";
};

datablock ExplosionData(SMASHBoundProjectileExplosion_Red) : SMASHBoundProjectileExplosion_Green
{
   emitter[0]     = SMASHBoundProjectileExplosionEmitter1_Red;
   emitter[1]     = SMASHBoundProjectileExplosionEmitter2_Red;
};

datablock LinearFlareProjectileData(SMASHBoundProjectile_Red) : SMASHBoundProjectile_Green
{
   explosion           = SMASHBoundProjectileExplosion_Red;
   flareColor        = "1.0 0.1 0.1";
   lightColor  = "1 0.1 0.1";
};

function getRandomDirection()
{
   if(mFloor(GetRandom() * 2) == 1)
   {
	%x = GetRandom() * 1;
   }
   else
   {
	%x = GetRandom() * -1;
   }
   if(mFloor(GetRandom() * 2) == 1)
   {
	%y = GetRandom() * 1;
   }
   else
   {
	%y = GetRandom() * -1;
   }
   if(mFloor(GetRandom() * 2) == 1)
   {
	%z = GetRandom() * 1;
   }
   else
   {
	%z = GetRandom() * -1;
   }
   return %x SPC %y SPC %z;
}

function SMASHBoundsKOEffect(%player)
{
   %DamagePercent = %player.preDeathDamagePercent;
   if(%DamagePercent < 40)
   {
      %data = "SMASHBoundProjectile_Green";
   }
   else if(%DamagePercent >= 40 && !(%DamagePercent >= 75))
   {
      %data = "SMASHBoundProjectile_Yellow";
   }
   else if(%DamagePercent >= 75)
   {
      %data = "SMASHBoundProjectile_Red";
   }
   for(%i = 0; %i < 6; %i++)
   {
      %orb = new LinearFlareProjectile() {
	   dataBlock = %data;
	   position = %player.position;
	   initialDirection = getRandomDirection();
	   initialPosition = %player.position;
           };
      MissionCleanup.add(%orb);
   }
}

datablock AudioProfile(SMASHKnockOutSound)
{
   filename    = "fx/misc/target_waypoint.wav";
   description = AudioClose3d;
   preload = true;
};

function leaveSMASHBounds(%player, %game)
{
   %killerID = %player.lastDamagerClient;
   %DamagerWeapon = %player.lastDamagerWeapon;
   if(%DamagerWeapon $= "")
      %DamagerWeapon = "None";

   %DamagePercent = mFloor(%player.getDamagePercent() * 100);
   %player.preDeathDamagePercent = %DamagePercent;
   if(%DamagePercent < 20)
   {
      %DamagePercentMSG = "\c3" @ %DamagePercent @ "%\c0";
   }
   else if(%DamagePercent >= 20 && !(%DamagePercent >= 40))
   {
      %DamagePercentMSG = "\c1" @ %DamagePercent @ "%\c0";
   }
   else if(%DamagePercent >= 40 && !(%DamagePercent >= 75))
   {
      %DamagePercentMSG = "\c2" @ %DamagePercent @ "%\c0";
   }
   else if(%DamagePercent >= 75)
   {
      %DamagePercentMSG = "\c5" @ %DamagePercent @ "%\c0";
   }

   if($SMASH::ReverseDamagePercentScore)
      %DamagePercentScore = 10 - mFloor(%player.getDamagePercent() * 10);
   else
      %DamagePercentScore = mFloor(%player.getDamagePercent() * 10);

   if(%killerID == %player.client)
   {
	if(%player.client.sex $= "Male")
	{
		%playergendermsg = "him";
	}
	else if(%player.client.sex $= "Female")
	{
		%playergendermsg = "her";
	}
	else
	{
		%playergendermsg = "it";
	}
	if($SMASH::KnockOutMSGShowDamageType)
	{
		messageAllExcept(%player.client, -1, 'ServerMessage', '\c0%1 was SMASHed out by %2self at %3 damage. [%4]', %player.client.name, %playergendermsg, %DamagePercentMSG, %DamagerWeapon);
		messageClient(%player.client, 'ServerMessage', '\c0You where SMASHed out by yourself at %1 damage. [%2]~wfx/misc/warning_beep.wav', %DamagePercentMSG, %DamagerWeapon);
	}
	else
	{
		messageAllExcept(%player.client, -1, 'ServerMessage', '\c0%1 was SMASHed out by %2self at %3 damage.', %player.client.name, %playergendermsg, %DamagePercentMSG);
		messageClient(%player.client, 'ServerMessage', '\c0You where SMASHed out by yourself at %1 damage.~wfx/misc/warning_beep.wav', %DamagePercentMSG);
	}
	if(%DamagePercentScore)
	{
		%player.client.smashScore = %player.client.smashScore - %DamagePercentScore;
	}
	%player.client.kills--;
	%player.client.suicides++;
   }
   else if(!%killerID)
   {
	if($SMASH::KnockOutMSGShowDamageType)
	{
		messageAllExcept(%player.client, -1, 'ServerMessage', '\c0%1 was SMASHed out at %2 damage. [%3]', %player.client.name, %DamagePercentMSG, %DamagerWeapon);
		messageClient(%player.client, 'ServerMessage', '\c0You where SMASHed out at %1 damage. [%2]~wfx/misc/warning_beep.wav', %DamagePercentMSG, %DamagerWeapon);
	}
	else
	{
		messageAllExcept(%player.client, -1, 'ServerMessage', '\c0%1 was SMASHed out at %2 damage.', %player.client.name, %DamagePercentMSG);
		messageClient(%player.client, 'ServerMessage', '\c0You where SMASHed out at %1 damage.~wfx/misc/warning_beep.wav', %DamagePercentMSG);
	}
	if(%DamagePercentScore)
	{
		%player.client.smashScore = %player.client.smashScore - %DamagePercentScore;
	}
	%player.client.deaths++;
   }
   else if(%killerID.team == %player.client.team && %game.numTeams > 1)
   {
	if($SMASH::KnockOutMSGShowDamageType)
	{
		messageAllExcept(%player.client, -1, 'ServerMessage', '\c0%1 was SMASHed out by teammate %2 at %3 damage. [%4]', %player.client.name, %killerID.name, %DamagePercentMSG, %DamagerWeapon);
		messageClient(%player.client, 'ServerMessage', '\c0You where SMASHed out by teammate %1 at %2 damage. [%3]~wfx/misc/warning_beep.wav', %killerID.name, %DamagePercentMSG, %DamagerWeapon);
	}
	else
	{
		messageAllExcept(%player.client, -1, 'ServerMessage', '\c0%1 was SMASHed out by teammate %2 at %3 damage.', %player.client.name, %killerID.name, %DamagePercentMSG);
		messageClient(%player.client, 'ServerMessage', '\c0You where SMASHed out by teammate %1 at %2 damage.~wfx/misc/warning_beep.wav', %killerID.name, %DamagePercentMSG);
	}
	if(%DamagePercentScore)
	{
		%killerID.smashScore = %killerID.smashScore - %DamagePercentScore;
	}
	%killerID.kills--;
	%player.client.deaths++;
        $TeamScore[%killerID.team]--; // only used in TDM
   }
   else
   {
	if($SMASH::KnockOutMSGShowDamageType)
	{
		messageAllExcept(%player.client, -1, 'ServerMessage', '\c0%1 was SMASHed out by %2 at %3 damage. [%4]', %player.client.name, %killerID.name, %DamagePercentMSG, %DamagerWeapon);
		messageClient(%player.client, 'ServerMessage', '\c0You where SMASHed out by %1 at %2 damage. [%3]~wfx/misc/warning_beep.wav', %killerID.name, %DamagePercentMSG, %DamagerWeapon);
	}
	else
	{
		messageAllExcept(%player.client, -1, 'ServerMessage', '\c0%1 was SMASHed out by %2 at %3 damage.', %player.client.name, %killerID.name, %DamagePercentMSG);
		messageClient(%player.client, 'ServerMessage', '\c0You where SMASHed out by %1 at %2 damage.~wfx/misc/warning_beep.wav', %killerID.name, %DamagePercentMSG);
	}
	if(%DamagePercentScore)
	{
		%killerID.smashScore = %killerID.smashScore + %DamagePercentScore;
	}
	%killerID.kills++;
	%player.client.deaths++;
        if(%game.numTeams > 1) $TeamScore[%killerID.team]++; // only used in TDM
        getAmmoLovin(%killerID);
	//%killerID.player.playAudio(0, SMASHKnockOutSound);
	messageClient(%killerID, '', '~wfx/misc/target_waypoint.wav');
   }
   PowerUpInvisibleDeactivate(%player);
   PowerUpInvincibleDeactivate(%player);
   PowerUpHasteDeactivate(%player);
   PowerUpEnergyDeactivate(%player);
   %game.recalcScore(%player.client);
   %game.recalcScore(%killerID);
   %game.onLeaveSMASHBounds(%player);
   %player.lastChance = 1;
   %player.blowup(); // chunkOrama!
   %player.scriptkill($DamageType::KnockOut);
   if($SMASH::KnockOutEffect)
      SMASHBoundsKOEffect(%player);

   if($SMASH::KnockOutEcho)
   {
      if(%killerId)
      {
         if($SMASH::KnockOutMSGShowDamageType)
            echo(%player.client.nameBase @ " \(CL: " @ %player.client @ " PL: " @ %player @ "\) SMASHed out by " @ %killerId.nameBase @ " \(CL: " @ %killerId @ " PL: " @ %killerId.player @ "\). [" @ %DamagerWeapon @ "]");
         else
            echo(%player.client.nameBase @ " \(CL: " @ %player.client @ " PL: " @ %player @ "\) SMASHed out by " @ %killerId.nameBase @ " \(CL: " @ %killerId @ " PL: " @ %killerId.player @ "\).");
      }
      else
      {
         if($SMASH::KnockOutMSGShowDamageType)
            echo(%player.client.nameBase @ " \(CL: " @ %player.client @ " PL: " @ %player @ "\) was SMASHed out. [" @ %DamagerWeapon @ "]");
         else
            echo(%player.client.nameBase @ " \(CL: " @ %player.client @ " PL: " @ %player @ "\) was SMASHed out.");
      }
   }
}
