datablock ParticleData(SMASHFallingJunkProjectileExplosionParticle1)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 600 * 2;
   lifetimeVarianceMS   = 000;
   textureName          = "special/crescent4";
   colors[0] = "1.0 1.0 1.0 1.0";
   colors[1] = "0.75 0.75 1.0 0.5";
   colors[2] = "0.5 0.5 1.0 0.0";
   sizes[0]      = 0.25 * 10;
   sizes[1]      = 0.5 * 10;
   sizes[2]      = 1.0 * 10;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(SMASHFallingJunkProjectileExplosionEmitter1)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.5;
   ejectionOffset   = 0.0;
   thetaMin         = 70;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 200;
   particles = "SMASHFallingJunkProjectileExplosionParticle1";
};

datablock ParticleData(SMASHFallingJunkProjectileExplosionParticle2)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 600 * 2;
   lifetimeVarianceMS   = 000;
   textureName          = "special/blasterHit";
   colors[0] = "1.0 1.0 1.0 1.0";
   colors[1] = "0.75 0.75 1.0 0.5";
   colors[2] = "0.5 0.5 1.0 0.0";
   sizes[0]      = 0.3 * 5;
   sizes[1]      = 0.90 * 5;
   sizes[2]      = 1.50 * 5;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(SMASHFallingJunkProjectileExplosionEmitter2)
{
   ejectionPeriodMS = 30;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = false;
   lifetimeMS       = 200;
   particles = "SMASHFallingJunkProjectileExplosionParticle2";
};

datablock ExplosionData(SMASHFallingJunkProjectileExplosion)
{
   emitter[0]     = SMASHFallingJunkProjectileExplosionEmitter1;
   emitter[1]     = SMASHFallingJunkProjectileExplosionEmitter2;
};

datablock LinearFlareProjectileData(SMASHFallingJunkProjectile)
{
   directDamage        = 0;
   directDamageType    = $DamageType::Default;
   hasDamageRadius     = false;
   indirectDamage      = 0.0;
   damageRadius        = 0.0;
   kickBackStrength    = 0;
   radiusDamageType    = $DamageType::Default;
   explosion           = SMASHFallingJunkProjectileExplosion;
   splash              = PlasmaSplash;

   dryVelocity       = 0.1;
   wetVelocity       = 0.1;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 16;
   lifetimeMS        = 32;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = -1;

   activateDelayMS = -1;

   scale             = "2 2 2";
   numFlares         = 30;
   flareColor        = "0.75 0.75 1.0";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "0.75 0.75 1.0";
};

function SMASHCreateFallingStuffEffect(%position)
{
   %effect0 = new LinearFlareProjectile() {
	dataBlock = "SMASHFallingJunkProjectile";
	position = %position;
	initialDirection = "0 0 -1";
	initialPosition = %position;
        };
   MissionCleanup.add(%effect0);
}

function getRandomPlayer()
{
   for(%i = 0; %i < ClientGroup.getCount(); %i++)
   {
      %cl = ClientGroup.getObject(%i);
      %pl = %cl.player;
      if(%pl)
      {
         if(%pllist)
         {
            %pllist = %pllist SPC %pl;
         }
         else
         {
            %pllist = %pl;
         }
      }
   }
   %randompl = getWord(%pllist,mFloor(GetRandom() * getWordCount(%pllist)));
   return %randompl;
}

function Item::applyRandomVelocity(%this)
{
   // this function is a morph of my getRandomDir() function in SMASHBounds.cs
   // this finds a random velocity and sets the item's velocity accordingly
   // this should only be used for Box Items
   %maxVel = 10; // actually 15 (%randomVel)
   %randomVel = 5 + GetRandom() * %maxVel;
   if(mFloor(GetRandom() * 2) == 1)
   {
	%x = GetRandom() * 1 * %randomVel;
   }
   else
   {
	%x = GetRandom() * -1 * %randomVel;
   }
   if(mFloor(GetRandom() * 2) == 1)
   {
	%y = GetRandom() * 1 * %randomVel;
   }
   else
   {
	%y = GetRandom() * -1 * %randomVel;
   }
   if(mFloor(GetRandom() * 2) == 1)
   {
	%z = GetRandom() * 1 * %randomVel;
   }
   else
   {
	%z = GetRandom() * -1 * %randomVel;
   }
   %vel = %x SPC %y SPC (%z + 1); // always give Z +1 so it has a little kick
   %this.setVelocity(%vel);
}

function SMASHCreateFallingStuff()
{
   if(!$SMASH::FallingStuffSpawnTime)
	$SMASH::FallingStuffSpawnTime = 30;

   %this = getRandomPlayer();
   if(!isObject(%this) || !$missionRunning || !$matchStarted || (!$SMASH::FallingHazards && !$SMASH::FallingItems))
   {
      Game.createFallingStuffSchedule = schedule($SMASH::FallingStuffSpawnTime * 1000, 0, SMASHCreateFallingStuff);
      return;
   }

   if(mFloor(GetRandom() * 4))
   {
	if($SMASH::FallingItems)
	{
	   SMASHCreateFallingItems(%this);
	}
	else
	{
	   SMASHCreateFallingHazards(%this);
	}
   }
   else
   {
	if($SMASH::FallingHazards)
	{
	   SMASHCreateFallingHazards(%this);
	}
	else
	{
	   SMASHCreateFallingItems(%this);
	}
   }
   if($SMASH::FallingStuffSpawnSFX)
   {
   	messageAll('', '~wgui/launchMenuOver.wav');
   }
   Game.createFallingStuffSchedule = schedule($SMASH::FallingStuffSpawnTime * 1000, 0, SMASHCreateFallingStuff);
}

//--------------------------------------------------------------------------
// Underwater SMASH Item Box Particle effects
//--------------------------------------------------------------------------
datablock ParticleData(SMASHItemBoxExplosionBubbleParticle)
{
   dragCoefficient      = 0.0;
   gravityCoefficient   = -0.25;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 2000;
   lifetimeVarianceMS   = 750;
   useInvAlpha          = false;
   textureName          = "special/bubbles";

   spinRandomMin        = -100.0;
   spinRandomMax        =  100.0;

   colors[0]     = "0.7 0.8 1.0 0.0";
   colors[1]     = "0.7 0.8 1.0 0.4";
   colors[2]     = "0.7 0.8 1.0 0.0";
   sizes[0]      = 0.75;
   sizes[1]      = 0.75;
   sizes[2]      = 0.75;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(SMASHItemBoxExplosionBubbleEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   ejectionOffset   = 2.0;
   velocityVariance = 0.5;
   thetaMin         = 0;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "SMASHItemBoxExplosionBubbleParticle";
};

datablock ParticleData(SMASHItemBoxBigBubbleParticle)
{
   dragCoefficient      = 0.0;
   gravityCoefficient   = -0.25;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   lifetimeMS           = 1500;
   lifetimeVarianceMS   = 600;
   useInvAlpha          = false;
   textureName          = "special/bubbles";

   spinRandomMin        = -100.0;
   spinRandomMax        =  100.0;

   colors[0]     = "0.7 0.8 1.0 0.0";
   colors[1]     = "0.7 0.8 1.0 0.4";
   colors[2]     = "0.7 0.8 1.0 0.0";
   sizes[0]      = 2.0;
   sizes[1]      = 2.0;
   sizes[2]      = 2.0;
   times[0]      = 0.0;
   times[1]      = 0.8;
   times[2]      = 1.0;
};
datablock ParticleEmitterData(SMASHItemBoxBigBubbleEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   ejectionOffset   = 7.0;
   velocityVariance = 0.5;
   thetaMin         = 0;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "SMASHItemBoxBigBubbleParticle";
};

datablock ParticleData(UnderwaterSMASHItemBoxExplosionSmoke)
{
   dragCoeffiecient     = 105.0;
   gravityCoefficient   = -0.25;   // rises slowly
   inheritedVelFactor   = 0.025;

   constantAcceleration = -1.0;
   
   lifetimeMS           = 1250;
   lifetimeVarianceMS   = 0;

   textureName          = "particleTest";

   useInvAlpha =  false;
   spinRandomMin = -200.0;
   spinRandomMax =  200.0;

   textureName = "special/Smoke/smoke_001";

   colors[0]     = "0.4 0.4 1.0 1.0";
   colors[1]     = "0.4 0.4 1.0 0.5";
   colors[2]     = "0.0 0.0 0.0 0.0";
   sizes[0]      = 6.0;
   sizes[1]      = 4.0;
   sizes[2]      = 2.0;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;

};

datablock ParticleEmitterData(UnderwaterSMASHItemBoxExplosionSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;

   ejectionVelocity = 5.25;
   velocityVariance = 0.25;

   thetaMin         = 0.0;
   thetaMax         = 180.0;

   lifetimeMS       = 250;

   particles = "UnderwaterSMASHItemBoxExplosionSmoke";
};

datablock ExplosionData(UnderwaterSMASHItemBoxSubExplosion1)
{
   offset = 1.0;
   emitter[0] = UnderwaterSMASHItemBoxExplosionSmokeEmitter;
};

datablock ExplosionData(UnderwaterSMASHItemBoxSubExplosion2)
{
   offset = 1.0;
   emitter[0] = UnderwaterSMASHItemBoxExplosionSmokeEmitter;
};

datablock ExplosionData(UnderwaterSMASHItemBoxExplosion)
{
   soundProfile   = GrenadeExplosionSound;

   emitter[0] = UnderwaterSMASHItemBoxExplosionSmokeEmitter;
   emitter[1] = SMASHItemBoxExplosionBubbleEmitter;
   emitter[2] = SMASHItemBoxBigBubbleEmitter;

   subExplosion[0] = UnderwaterSMASHItemBoxSubExplosion1;
   subExplosion[1] = UnderwaterSMASHItemBoxSubExplosion2;
   
   shakeCamera = true;
   camShakeFreq = "12.0 13.0 11.0";
   camShakeAmp = "35.0 35.0 35.0";
   camShakeDuration = 1.0;
   camShakeRadius = 15.0;
};

//--------------------------------------------------------------------------
// SMASH Item Box Particle effects
//--------------------------------------------------------------------------

datablock ParticleData(SMASHItemBoxExplosionSmoke)
{
   dragCoeffiecient     = 105.0;
   gravityCoefficient   = -0.25;   // rises slowly
   inheritedVelFactor   = 0.025;

   constantAcceleration = -0.80;
   
   lifetimeMS           = 1250;
   lifetimeVarianceMS   = 0;

   textureName          = "particleTest";

   useInvAlpha =  true;
   spinRandomMin = -200.0;
   spinRandomMax =  200.0;

   textureName = "special/Smoke/smoke_001";

   colors[0]     = "0.2 0.2 0.2 1.0";
   colors[1]     = "0.4 0.4 0.4 1.0";
   colors[2]     = "0.6 0.6 0.6 1.0";
   sizes[0]      = 6.0;
   sizes[1]      = 4.0;
   sizes[2]      = 2.0;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;

};

datablock ParticleEmitterData(SMASHItemBoxExplosionSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;

   ejectionVelocity = 10.25;
   velocityVariance = 0.25;

   thetaMin         = 0.0;
   thetaMax         = 180.0;

   lifetimeMS       = 250;

   particles = "SMASHItemBoxExplosionSmoke";
};

datablock ParticleData(SMASHItemBoxBigSmoke)
{
   dragCoeffiecient     = 0.4;
   gravityCoefficient   = -0.30;   // rises slowly
   inheritedVelFactor   = 0.025;

   lifetimeMS           = 1250;
   lifetimeVarianceMS   = 500;

   textureName          = "particleTest";

   useInvAlpha =  true;
   spinRandomMin = -100.0;
   spinRandomMax =  100.0;

   textureName = "special/Smoke/bigSmoke";

   colors[0]     = "0.7 0.7 0.7 0.0";
   colors[1]     = "0.4 0.4 0.4 0.5";
   colors[2]     = "0.4 0.4 0.4 0.5";
   colors[3]     = "0.4 0.4 0.4 0.0";
   sizes[0]      = 5.0;
   sizes[1]      = 6.0;
   sizes[2]      = 10.0;
   sizes[3]      = 12.0;
   times[0]      = 0.0;
   times[1]      = 0.333;
   times[2]      = 0.666;
   times[3]      = 1.0;
};

datablock ParticleEmitterData(SMASHItemBoxBigSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;

   ejectionOffset = 8.0;


   ejectionVelocity = 1.25;
   velocityVariance = 1.2;

   thetaMin         = 0.0;
   thetaMax         = 90.0;

   lifetimeMS       = 500;

   particles = "SMASHItemBoxBigSmoke";

};

//----------------------------------------------------
//  Explosion
//----------------------------------------------------

datablock ExplosionData(SMASHItemBoxSubExplosion1)
{
   offset = 2.0;
   emitter[0] = SMASHItemBoxExplosionSmokeEmitter;
};

datablock ExplosionData(SMASHItemBoxSubExplosion2)
{
   offset = 2.0;
   emitter[0] = SMASHItemBoxExplosionSmokeEmitter;
};

datablock ExplosionData(SMASHItemBoxExplosion)
{
   soundProfile   = GrenadeExplosionSound;

   emitter[0] = SMASHItemBoxExplosionSmokeEmitter;
   emitter[1] = SMASHItemBoxBigSmokeEmitter;

   subExplosion[0] = SMASHItemBoxSubExplosion1;
   subExplosion[1] = SMASHItemBoxSubExplosion2;
   
   shakeCamera = true;
   camShakeFreq = "12.0 13.0 11.0";
   camShakeAmp = "35.0 35.0 35.0";
   camShakeDuration = 1.0;
   camShakeRadius = 15.0;
};

datablock DebrisData( ItemBoxDebris )
{
   explodeOnMaxBounce = false;

   elasticity = 0.20;
   friction = 0.5;

   lifetime = 3.0; // very short for no spamming
   lifetimeVariance = 1.0;

   minSpinSpeed = 60;
   maxSpinSpeed = 600;

   numBounces = 10;
   bounceVariance = 0;

   staticOnMaxBounce = true;

   useRadiusMass = true;
   baseRadius = 0.4;

   velocity = 9.0;
   velocityVariance = 4.5;
};             

datablock ItemData(SMASHItemBox)
{
   catagory = "SMASH Falling Items";
   shapeFile = "stackable3m.dts";
   mass = 100.0; // make it fr00gen heavy
   elasticity = 0.1;
   friction = 0.9;
   rotate = false;
   collideable = true; // make it solid
   static = false;
   sticky = true;
   pickupRadius = 0;
   noTimeout = false; // In SSB the boxes would disappear just like all other items.

   explosion = SMASHItemBoxExplosion;
   underwaterExplosion = UnderwaterSMASHItemBoxExplosion;
   maxDamage = 0.5;
   kickBackStrength    = 400;

   debrisShapeName = "debris_generic.dts";
   debris = ItemBoxDebris;

   computeCRC = true;
};

function SMASHItemBox::onAdd(%this, %obj)
{
   // make sure the box is scaled correctly
   Parent::onAdd(%this, %obj);
   %obj.scale = "0.75 1.5 1.25";
   // make sure its set up how it should be
   %obj.rotate = false;
   %obj.collideable = true; // can it fall on someone...? doesnt make it sold
   %obj.static = false;
}

datablock StaticShapeData(SMASHItemBox_Static) : StaticShapeDamageProfile
{
   catagory = "SMASH Falling Items";
   shapeFile = "stackable3m.dts";

   explosion = SMASHItemBoxExplosion;
   underwaterExplosion = UnderwaterSMASHItemBoxExplosion;
   maxDamage = 0.5;
   destroyedLevel = 0.5;
   disabledLevel = 0.5;
   kickBackStrength    = 400;
   isShielded = false;

   debrisShapeName = "debris_generic.dts";
   debris = ItemBoxDebris;
};

function SMASHItemBox_Static::onAdd(%this, %obj)
{
   // make sure the static box is scaled correctly too
   Parent::onAdd(%this, %obj);
   %obj.scale = "0.75 1.5 1.25";
   // So the static box will fade just like items
   %itemFadeTime = 3000;
   %obj.startFade(%itemFadeTime, $ItemPopTime - %itemFadeTime, true);
   %obj.schedule($ItemPopTime, "delete");
}

function SMASHItemBox::onStickyCollision(%data, %obj)
{
   // We don't want the box to be moving when it becomes a static.
   if(GetWord(%obj.getVelocity(),0) <= 0.1 && GetWord(%obj.getVelocity(),1) <= 0.1 && GetWord(%obj.getVelocity(),2) <= 0.1)
   {
      %staticBox = new StaticShape() {
         dataBlock = "SMASHItemBox_Static";
         position = %obj.position;
      };
      MissionCleanup.add(%staticBox);
      %obj.delete();
   }
}

function SMASHItemBox::onEnterLiquid(%data, %obj, %coverage, %type)
{
   // lava types
   if(%type >=4 && %type <= 6)
   {
      if(%obj.getDamageState() !$= "Destroyed")
      {
         %obj.setDamageState(Destroyed);
         %obj.blowup(); 
         return;
      }
   }

  Parent::onEnterLiquid(%data, %obj, %coverage, %type);
}

function SMASHItemBox::spawnRandomBoxItem(%this)
{
   %numItems = 15;
   if(mFloor(GetRandom() * %numItems) == 1)
   {
	%item = "RepairKit";
   }
   else if(mFloor(GetRandom() * %numItems) == 2)
   {
	%item = "RepairPatch";
   }
   else if(mFloor(GetRandom() * %numItems) == 3)
   {
	%item = "ChaingunAmmo";
   }
   else if(mFloor(GetRandom() * %numItems) == 4)
   {
	%item = "DiscAmmo";
   }
   else if(mFloor(GetRandom() * %numItems) == 5)
   {
	%item = "GrenadeLauncherAmmo";
   }
   else if(mFloor(GetRandom() * %numItems) == 6)
   {
	%item = "MissileLauncherAmmo";
   }
   else if(mFloor(GetRandom() * %numItems) == 7)
   {
	%item = "MortarAmmo";
   }
   else if(mFloor(GetRandom() * %numItems) == 8)
   {
	%item = "PlasmaAmmo";
   }
   else if(mFloor(GetRandom() * %numItems) == 9)
   {
	%item = "ConcussionGrenade";
   }
   else if(mFloor(GetRandom() * %numItems) == 10)
   {
	%item = "FlareGrenade";
   }
   else if(mFloor(GetRandom() * %numItems) == 11)
   {
	%item = "FlashGrenade";
   }
   else if(mFloor(GetRandom() * %numItems) == 12)
   {
	%item = "Grenade";
   }
   else if(mFloor(GetRandom() * %numItems) == 13)
   {
	%item = "Mine";
   }
   else if(mFloor(GetRandom() * %numItems) == 14)
   {
	%item = "FLUDDCannon";
   }
   else
   {
	%item = "Beacon";
   }
   %boxItem = new Item() {
      dataBlock = %item;
      position = %this.position;
      static = false;
      rotate = false;
   };
   MissionCleanup.add(%boxItem);
   %boxItem.schedulePop();
   %boxItem.applyRandomVelocity();
}

function SMASHItemBox::onDestroyed(%this, %object, %lastState)
{
   if(%object.kaboom)
      return;
   else
   {
      %object.kaboom = true;
      %dmgRadius = 10;
      %dmgMod = 0.3;
      %expImpulse = 400;
      %dmgType = $DamageType::Explosion;

      %object.blowingUp = true;

      if($SMASH::MinBoxItems $= "") $SMASH::MinBoxItems = 3;
      if($SMASH::MaxBoxItems $= "") $SMASH::MaxBoxItems = 6;
      // this goes after just in case (think about it, you'll figure out why)
      if($SMASH::MinBoxItems > $SMASH::MaxBoxItems) $SMASH::MinBoxItems = $SMASH::MaxBoxItems;
      %minItems = $SMASH::MinBoxItems;
      %maxItems = $SMASH::MaxBoxItems;
      for(%i = 0; %i < %minItems + (GetRandom() * (%maxItems - %minItems)); %i++)
         SMASHItemBox::spawnRandomBoxItem(%object);

      RadiusExplosion(%object, %object.getPosition(), %dmgRadius, %dmgMod, %expImpulse, -1, %dmgType);

      %object.schedule(100, "delete");
   }
}

function SMASHItemBox_Static::onDestroyed(%this, %object, %lastState)
{
   SMASHItemBox::onDestroyed(%this, %object, %lastState);
}

function SMASHItemBox::onCollision(%data,%obj,%col)
{
   // Do nothing...
}

function SMASHItemBox::damageObject(%data, %targetObject, %sourceObject, %position, %amount, %damageType)
{
   if (!%object.blowingUp)
   {
      %targetObject.damaged += %amount;

      if(%targetObject.damaged >= %targetObject.getDataBlock().maxDamage && %targetObject.getDamageState() !$= Destroyed)
      {   
         %targetObject.setDamageState(Destroyed);
         %targetObject.blowup(); 
      }
   }
}

function SMASHItemBox::shouldApplyImpulse(%data, %obj)
{
   return true; // make it bounce around when hit
}

function SMASHCreateFallingItems(%this)
{
   %numItems = 16;
   if(mFloor(GetRandom() * %numItems) == 1)
   {
	%item = "RepairKit";
   }
   else if(mFloor(GetRandom() * %numItems) == 2)
   {
	%item = "RepairPatch";
   }
   else if(mFloor(GetRandom() * %numItems) == 3)
   {
	%item = "ChaingunAmmo";
   }
   else if(mFloor(GetRandom() * %numItems) == 4)
   {
	%item = "DiscAmmo";
   }
   else if(mFloor(GetRandom() * %numItems) == 5)
   {
	%item = "GrenadeLauncherAmmo";
   }
   else if(mFloor(GetRandom() * %numItems) == 6)
   {
	%item = "MissileLauncherAmmo";
   }
   else if(mFloor(GetRandom() * %numItems) == 7)
   {
	%item = "MortarAmmo";
   }
   else if(mFloor(GetRandom() * %numItems) == 8)
   {
	%item = "PlasmaAmmo";
   }
   else if(mFloor(GetRandom() * %numItems) == 9)
   {
	%item = "ConcussionGrenade";
   }
   else if(mFloor(GetRandom() * %numItems) == 10)
   {
	%item = "FlareGrenade";
   }
   else if(mFloor(GetRandom() * %numItems) == 11)
   {
	%item = "FlashGrenade";
   }
   else if(mFloor(GetRandom() * %numItems) == 12)
   {
	%item = "Grenade";
   }
   else if(mFloor(GetRandom() * %numItems) == 13)
   {
	%item = "Mine";
   }
   else if(mFloor(GetRandom() * %numItems) == 14)
   {
	%item = "Beacon";
   }
   else if(mFloor(GetRandom() * %numItems) == 15)
   {
	%item = "FLUDDCannon";
   }
   else
   {
	%item = "SMASHItemBox";
   }

   if(mFloor(GetRandom() * 2) == 1)
   {
	%x = GetRandom() * 50;
   }
   else
   {
	%x = GetRandom() * -50;
   }
   if(mFloor(GetRandom() * 2) == 1)
   {
	%y = GetRandom() * 50;
   }
   else
   {
	%y = GetRandom() * -50;
   }
   %z = 50 + (GetRandom() * 50);
   %fallingItem = new Item() {
      dataBlock = %item;
      position = VectorAdd(%this.position, %x SPC %y SPC %z);
      static = false;
      rotate = false;
   };
   MissionCleanup.add(%fallingItem);
   SMASHCreateFallingStuffEffect(%fallingItem.position);
   %fallingItem.schedulePop();
   %downVel = -0.5 + (GetRandom() * -4.5);
   %fallingItem.setVelocity("0 0 " @ %downVel);
   if($SMASH::FallingStuffSpawnEcho)
      echo("FallingItem Added: Type \"" @ %item @ "\" Position \"" @ %fallingItem.position @ "\" Near \"" @ %this.client.nameBase @ " \(CL: " @ %this.client @ " PL: " @ %this @ "\)\".");
}


datablock LinearProjectileData(DiscProjectile_Hazard)
{
   projectileShapeName = "disc.dts";
   emitterDelay        = -1;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 0.50;
   damageRadius        = 7.5;
   radiusDamageType    = $DamageType::Hazard;
   kickBackStrength    = 7500;

   sound 				= discProjectileSound;
   explosion           = "DiscExplosion";
   underwaterExplosion = "UnderwaterDiscExplosion";
   splash              = DiscSplash;

   dryVelocity       = 90;
   wetVelocity       = 50;
   velInheritFactor  = 0.5;
   fizzleTimeMS      = 5000;
   lifetimeMS        = 5000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 15.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 5000;

   activateDelayMS = 200;

   hasLight    = true;
   lightRadius = 6.0;
   lightColor  = "0.175 0.175 0.5";
};

datablock GrenadeProjectileData(BasicGrenade_Hazard)
{
   projectileShapeName = "grenade_projectile.dts";
   emitterDelay        = -1;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 0.40;
   damageRadius        = 15.0;
   radiusDamageType    = $DamageType::Hazard;
   kickBackStrength    = 7500;
   bubbleEmitTime      = 1.0;

   sound               = GrenadeProjectileSound;
   explosion           = "GrenadeExplosion";
   underwaterExplosion = "UnderwaterGrenadeExplosion";
   velInheritFactor    = 0.5;
   splash              = GrenadeSplash;

   baseEmitter         = GrenadeSmokeEmitter;
   bubbleEmitter       = GrenadeBubbleEmitter;

   grenadeElasticity = 0.35;
   grenadeFriction   = 0.2;
   armingDelayMS     = 1000;
   muzzleVelocity    = 47.00;
   drag = 0.1;
};

datablock LinearFlareProjectileData(PlasmaBolt_Hazard)
{
   projectileShapeName = "plasmabolt.dts";
   scale               = "2.0 2.0 2.0";
   faceViewer          = true;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 0.45;
   damageRadius        = 4.0;
   kickBackStrength    = 7500;
   radiusDamageType    = $DamageType::Hazard;

   explosion           = "PlasmaBoltExplosion";
   splash              = PlasmaSplash;

   dryVelocity       = 55.0;
   wetVelocity       = -1;
   velInheritFactor  = 0.3;
   fizzleTimeMS      = 2000;
   lifetimeMS        = 3000;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = -1;

   //activateDelayMS = 100;
   activateDelayMS = -1;

   size[0]           = 0.2;
   size[1]           = 0.5;
   size[2]           = 0.1;


   numFlares         = 35;
   flareColor        = "1 0.75 0.25";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";

	sound        = PlasmaProjectileSound;
   fireSound    = PlasmaFireSound;
   wetFireSound = PlasmaFireWetSound;
   
   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "1 0.75 0.25";
};

datablock BombProjectileData(BomberBomb_Hazard) // Boombastic Reign of Death
{
   projectileShapeName  = "bomb.dts";
   emitterDelay         = -1;
   directDamage         = 0.0;
   hasDamageRadius      = true;
   indirectDamage       = 1.1;
   damageRadius         = 30;
   radiusDamageType     = $DamageType::Hazard;
   kickBackStrength     = 7500;

   explosion            = "VehicleBombExplosion";
   velInheritFactor     = 1.0;

   grenadeElasticity    = 0.25;
   grenadeFriction      = 0.4;
   armingDelayMS        = 2000;
   muzzleVelocity       = 0.1;
   drag                 = 0.3;

   minRotSpeed          = "60.0 0.0 0.0";
   maxRotSpeed          = "80.0 0.0 0.0";
   scale                = "1.0 1.0 1.0";
   
   sound                = BomberBombProjectileSound;
};

datablock GrenadeProjectileData(MortarShot_Hazard)
{
   projectileShapeName = "mortar_projectile.dts";
   emitterDelay        = -1;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 1.0;
   damageRadius        = 20.0;
   radiusDamageType    = $DamageType::Hazard;
   kickBackStrength    = 7500;

   explosion           = "MortarExplosion";
   underwaterExplosion = "UnderwaterMortarExplosion";
   velInheritFactor    = 0.5;
   splash              = MortarSplash;
   depthTolerance      = 10.0; // depth at which it uses underwater explosion
   
   baseEmitter         = MortarSmokeEmitter;
   bubbleEmitter       = MortarBubbleEmitter;
   
   grenadeElasticity = 0.15;
   grenadeFriction   = 0.4;
   armingDelayMS     = 2000;
   muzzleVelocity    = 63.7;
   drag              = 0.1;

   sound			 = MortarProjectileSound;

   hasLight    = true;
   lightRadius = 4;
   lightColor  = "0.05 0.2 0.05";

   hasLightUnderwaterColor = true;
   underWaterLightColor = "0.05 0.075 0.2";

};

datablock EnergyProjectileData(EnergyBolt_Hazard)
{
   emitterDelay        = -1;
   directDamage        = 1.0;
   directDamageType    = $DamageType::BulletHazard;
   kickBackStrength    = 5000.0;
   bubbleEmitTime      = 1.0;

   sound = BlasterProjectileSound;
   velInheritFactor    = 0.5;

   explosion           = "BlasterExplosion";
   splash              = BlasterSplash;


   grenadeElasticity = 0.998;
   grenadeFriction   = 0.0;
   armingDelayMS     = 500;

   muzzleVelocity    = 90.0 * 2;

   drag = 0.05;

   gravityMod        = 0.0;

   dryVelocity       = 200.0 * 2;
   wetVelocity       = 150.0 * 2;

   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "0.5 0.175 0.175";

   scale = "0.25 20.0 1.0";
   crossViewAng = 0.99;
   crossSize = 0.55;

   lifetimeMS     = 3000;
   blurLifetime   = 0.2;
   blurWidth      = 0.25;
   blurColor = "0.4 0.0 0.0 1.0";

   texture[0] = "special/blasterBolt";
   texture[1] = "special/blasterBoltCross";
};

datablock TracerProjectileData(ChaingunBullet_Hazard)
{
   doDynamicClientHits = true;

   directDamage        = 1.0;
   directDamageType    = $DamageType::BulletHazard;
   explosion           = "ChaingunExplosion";
   splash              = ChaingunSplash;

   kickBackStrength    = 5000.0;
   sound 				= ChaingunProjectile;

   dryVelocity       = 425.0;
   wetVelocity       = 100.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 3000;
   lifetimeMS        = 3000;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   tracerLength    = 15.0;
   tracerAlpha     = false;
   tracerMinPixels = 6;
   tracerColor     = 211.0/255.0 @ " " @ 215.0/255.0 @ " " @ 120.0/255.0 @ " 0.75";
	tracerTex[0]  	 = "special/tracer00";
	tracerTex[1]  	 = "special/tracercross";
	tracerWidth     = 0.10;
   crossSize       = 0.20;
   crossViewAng    = 0.990;
   renderCross     = true;

   decalData[0] = ChaingunDecal1;
   decalData[1] = ChaingunDecal2;
   decalData[2] = ChaingunDecal3;
   decalData[3] = ChaingunDecal4;
   decalData[4] = ChaingunDecal5;
   decalData[5] = ChaingunDecal6;
};

datablock TracerProjectileData(AABullet_Hazard)
{
   doDynamicClientHits = true;

   projectileShapeName = "energy_bolt.dts";
   directDamage        = 1.0;
   directDamageType    = $DamageType::BulletHazard;
   explosion           = "AABulletExplosion";
   splash              = ChaingunSplash;
   kickBackStrength    = 5000.0;

   dryVelocity       = 150.0;
   wetVelocity       = 100.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 3000;
   lifetimeMS        = 3000;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   tracerLength    = 20;
   tracerAlpha     = false;
   tracerMinPixels = 3;
   tracerColor     = "1 1 1 1";
	tracerTex[0]  	 = "special/shrikeBolt";
	tracerTex[1]  	 = "special/shrikeBoltCross";
	tracerWidth     = 0.55;
   crossSize       = 0.99;
   crossViewAng    = 0.990;
   renderCross     = true;
   emap = true;
};

datablock TracerProjectileData(ScoutChaingunBullet_Hazard)
{
   doDynamicClientHits = true;

   directDamage        = 1.0;
   explosion           = "ScoutChaingunExplosion";
   splash              = ChaingunSplash;

   directDamageType    = $DamageType::BulletHazard;
   kickBackStrength    = 5000.0;

   sound = ShrikeBlasterProjectileSound;

   dryVelocity       = 425.0;
   wetVelocity       = 100.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 1000;
   lifetimeMS        = 1000;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   tracerLength    = 45.0;
   tracerAlpha     = false;
   tracerMinPixels = 6;
   tracerColor     = "1.0 1.0 1.0 1.0";
	tracerTex[0]  	 = "special/shrikeBolt";
	tracerTex[1]  	 = "special/shrikeBoltCross";
	tracerWidth     = 0.55;
   crossSize       = 0.99;
   crossViewAng    = 0.990;
   renderCross     = true;

};

datablock LinearFlareProjectileData(PlasmaBarrelBolt_Hazard)
{
   doDynamicClientHits = true;

   directDamage        = 0;
   directDamageType    = $DamageType::Hazard;
   hasDamageRadius     = true;
   indirectDamage      = 1.0;
   damageRadius        = 10.0;
   kickBackStrength    = 7500;
   radiusDamageType    = $DamageType::Hazard;
   explosion           = PlasmaBarrelBoltExplosion;
   splash              = PlasmaSplash;

   dryVelocity       = 50.0;
   wetVelocity       = -1;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 4000;
   lifetimeMS        = 6000;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = -1;

   activateDelayMS = 100;

   scale             = "1.5 1.5 1.5";
   numFlares         = 30;
   flareColor        = "0.1 0.3 1.0";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";
};

function SMASHCreateFallingHazards(%this)
{
   %numHazards = 9;
   if(mFloor(GetRandom() * 2) == 1)
   {
	%x = GetRandom() * 50;
   }
   else
   {
	%x = GetRandom() * -50;
   }
   if(mFloor(GetRandom() * 2) == 1)
   {
	%y = GetRandom() * 50;
   }
   else
   {
	%y = GetRandom() * -50;
   }
   %z = 50 + (GetRandom() * 50);

   if(mFloor(GetRandom() * %numHazards) == 1)
   {
      %fallingHazard = new LinearProjectile() {
         dataBlock = "DiscProjectile_Hazard";
         position = VectorAdd(%this.position, %x SPC %y SPC %z);
         initialDirection = "0 0 -1";
         initialPosition = VectorAdd(%this.position, %x SPC %y SPC %z);
      };
   }
   else if(mFloor(GetRandom() * %numHazards) == 2)
   {
      %fallingHazard = new GrenadeProjectile() {
         dataBlock = "BasicGrenade_Hazard";
         position = VectorAdd(%this.position, %x SPC %y SPC %z);
         initialDirection = "0 0 -1";
         initialPosition = VectorAdd(%this.position, %x SPC %y SPC %z);
      };
   }
   else if(mFloor(GetRandom() * %numHazards) == 3)
   {
      %fallingHazard = new LinearFlareProjectile() {
         dataBlock = "PlasmaBolt_Hazard";
         position = VectorAdd(%this.position, %x SPC %y SPC %z);
         initialDirection = "0 0 -1";
         initialPosition = VectorAdd(%this.position, %x SPC %y SPC %z);
      };
   }
   else if(mFloor(GetRandom() * %numHazards) == 4)
   {
      %fallingHazard = new BombProjectile() {
         dataBlock = "BomberBomb_Hazard";
         position = VectorAdd(%this.position, %x SPC %y SPC %z);
         initialDirection = "0 0 -1";
         initialPosition = VectorAdd(%this.position, %x SPC %y SPC %z);
      };
   }
   else if(mFloor(GetRandom() * %numHazards) == 5)
   {
      %fallingHazard = new EnergyProjectile() {
         dataBlock = "EnergyBolt_Hazard";
         position = VectorAdd(%this.position, %x SPC %y SPC %z);
         initialDirection = "0 0 -1";
         initialPosition = VectorAdd(%this.position, %x SPC %y SPC %z);
      };
      for(%i = 0; %i < 4 + mFloor(GetRandom() * 5); %i++) 
      {
         %fallingHazardBurst = new EnergyProjectile() {
            dataBlock = "EnergyBolt_Hazard";
            position = VectorAdd(%fallingHazard.position, (GetRandom() * 25) SPC (GetRandom() * 25) SPC (0));
            initialDirection = "0 0 -1";
            initialPosition = VectorAdd(%fallingHazard.position, (GetRandom() * 25) SPC (GetRandom() * 25) SPC (0));
         };
         MissionCleanup.add(%fallingHazardBurst);
         SMASHCreateFallingStuffEffect(%fallingHazardBurst.position);
      }
   }
   else if(mFloor(GetRandom() * %numHazards) == 6)
   {
      %fallingHazard = new TracerProjectile() {
         dataBlock = "ChaingunBullet_Hazard";
         position = VectorAdd(%this.position, %x SPC %y SPC %z);
         initialDirection = "0 0 -1";
         initialPosition = VectorAdd(%this.position, %x SPC %y SPC %z);
      };
      for(%i = 0; %i < 4 + mFloor(GetRandom() * 5); %i++) 
      {
         %fallingHazardBurst = new TracerProjectile() {
            dataBlock = "ChaingunBullet_Hazard";
            position = VectorAdd(%fallingHazard.position, (GetRandom() * 25) SPC (GetRandom() * 25) SPC (0));
            initialDirection = "0 0 -1";
            initialPosition = VectorAdd(%fallingHazard.position, (GetRandom() * 25) SPC (GetRandom() * 25) SPC (0));
         };
         MissionCleanup.add(%fallingHazardBurst);
         SMASHCreateFallingStuffEffect(%fallingHazardBurst.position);
      }
   }
   else if(mFloor(GetRandom() * %numHazards) == 7)
   {
      %fallingHazard = new TracerProjectile() {
         dataBlock = "AABullet_Hazard";
         position = VectorAdd(%this.position, %x SPC %y SPC %z);
         initialDirection = "0 0 -1";
         initialPosition = VectorAdd(%this.position, %x SPC %y SPC %z);
      };
      for(%i = 0; %i < 4 + mFloor(GetRandom() * 5); %i++) 
      {
         %fallingHazardBurst = new TracerProjectile() {
            dataBlock = "AABullet_Hazard";
            position = VectorAdd(%fallingHazard.position, (GetRandom() * 25) SPC (GetRandom() * 25) SPC (0));
            initialDirection = "0 0 -1";
            initialPosition = VectorAdd(%fallingHazard.position, (GetRandom() * 25) SPC (GetRandom() * 25) SPC (0));
         };
         MissionCleanup.add(%fallingHazardBurst);
         SMASHCreateFallingStuffEffect(%fallingHazardBurst.position);
      }
   }
   else if(mFloor(GetRandom() * %numHazards) == 8)
   {
      %fallingHazard = new TracerProjectile() {
         dataBlock = "ScoutChaingunBullet_Hazard";
         position = VectorAdd(%this.position, %x SPC %y SPC %z);
         initialDirection = "0 0 -1";
         initialPosition = VectorAdd(%this.position, %x SPC %y SPC %z);
      };
      for(%i = 0; %i < 4 + mFloor(GetRandom() * 5); %i++) 
      {
         %fallingHazardBurst = new TracerProjectile() {
            dataBlock = "ScoutChaingunBullet_Hazard";
            position = VectorAdd(%fallingHazard.position, (GetRandom() * 25) SPC (GetRandom() * 25) SPC (0));
            initialDirection = "0 0 -1";
            initialPosition = VectorAdd(%fallingHazard.position, (GetRandom() * 25) SPC (GetRandom() * 25) SPC (0));
         };
         MissionCleanup.add(%fallingHazardBurst);
         SMASHCreateFallingStuffEffect(%fallingHazardBurst.position);
      }
   }
   else if(mFloor(GetRandom() * %numHazards) == 9)
   {
      %fallingHazard = new LinearFlareProjectile() {
         dataBlock = "PlasmaBarrelBolt_Hazard";
         position = VectorAdd(%this.position, %x SPC %y SPC %z);
         initialDirection = "0 0 -1";
         initialPosition = VectorAdd(%this.position, %x SPC %y SPC %z);
      };
   }
   else
   {
      %fallingHazard = new GrenadeProjectile() {
         dataBlock = "MortarShot_Hazard";
         position = VectorAdd(%this.position, %x SPC %y SPC %z);
         initialDirection = "0 0 -1";
         initialPosition = VectorAdd(%this.position, %x SPC %y SPC %z);
      };
   }
   MissionCleanup.add(%fallingHazard);
   SMASHCreateFallingStuffEffect(%fallingHazard.position);
   if($SMASH::FallingStuffSpawnEcho)
      echo("FallingHazard Added: Type \"" @ %fallingHazard.dataBlock.getName() @ "\" Position \"" @ %fallingHazard.position @ "\" Near \"" @ %this.client.nameBase @ " \(CL: " @ %this.client @ " PL: " @ %this @ "\)\".");
}