datablock StaticShapeData(PowerUpDispencer)
{     
   catagory = "SMASH PowerUps";
   shapefile = "teamlogo_projector.dts";   
};

datablock StaticShapeData(Invincibility_PowerUp)
{
   catagory = "SMASH PowerUps";
   shapeFile = "teamlogo_storm.dts";
   alwaysAmbient = true;
};

datablock StaticShapeData(Invisibility_PowerUp)
{
   catagory = "SMASH PowerUps";
   shapeFile = "teamlogo_inf.dts";
   alwaysAmbient = true;
};

datablock StaticShapeData(Haste_PowerUp)
{
   catagory = "SMASH PowerUps";
   shapeFile = "teamlogo_sw.dts";
   alwaysAmbient = true;
};

datablock StaticShapeData(Energy_PowerUp)
{
   catagory = "SMASH PowerUps";
   shapeFile = "teamlogo_bd.dts";
   alwaysAmbient = true;
};

datablock StaticShapeData(TeamHeal_PowerUp)
{
   catagory = "SMASH PowerUps";
   shapeFile = "teamlogo_be.dts";
   alwaysAmbient = true;
};

datablock StaticShapeData(Unused_PowerUp_1)
{
   catagory = "SMASH PowerUps";
   shapeFile = "teamlogo_ds.dts";
   alwaysAmbient = true;
};

datablock StaticShapeData(Quake_PowerUp)
{
   catagory = "SMASH PowerUps";
   shapeFile = "teamlogo_hb.dts";
   alwaysAmbient = true;
};

function SMASHPowerUpEffect(%player)
{
   %effect0 = new EnergyProjectile() {
	dataBlock = "SpawnEffectBolt";
	position = VectorAdd(%player.position, "3 0 0");
	initialDirection = "0 0 1";
	initialPosition = VectorAdd(%player.position, "3 0 0");
	rotation = %player.rotation;
        };
   %effect1 = new EnergyProjectile() {
	dataBlock = "SpawnEffectBolt";
	position = VectorAdd(%player.position, "0 3 0");
	initialDirection = "0 0 1";
	initialPosition = VectorAdd(%player.position, "0 3 0");
	rotation = %player.rotation;
        };
   %effect2 = new EnergyProjectile() {
	dataBlock = "SpawnEffectBolt";
	position = VectorAdd(%player.position, "-3 0 0");
	initialDirection = "0 0 1";
	initialPosition = VectorAdd(%player.position, "-3 0 0");
	rotation = %player.rotation;
        };
   %effect3 = new EnergyProjectile() {
	dataBlock = "SpawnEffectBolt";
	position = VectorAdd(%player.position, "0 -3 0");
	initialDirection = "0 0 1";
	initialPosition = VectorAdd(%player.position, "0 -3 0");
	rotation = %player.rotation;
        };
   MissionCleanup.add(%effect0);
   MissionCleanup.add(%effect1);
   MissionCleanup.add(%effect2);
   MissionCleanup.add(%effect3);
   %effect0.schedule(900, delete);
   %effect1.schedule(900, delete);
   %effect2.schedule(900, delete);
   %effect3.schedule(900, delete);
}

function PowerUpDispencer_Initiate()
{
   %group = nameToID("MissionGroup/PowerUpDispencerGroup");
   if(!isObject(%group)) return; // map doesnt allow powerups?

   for(%i = 0; %i < %group.getCount(); %i++)
   {
      %dispencer = %group.getObject(%i);
      %data = %dispencer.getDataBlock();
      if(%data.getName() $= "PowerUpDispencer")
      {
         %dispencer.dispenceDelay = 1;
         %dispencer.initiated = 1;
         Game.PowerUpRefresh = schedule($SMASH::PowerUpRefreshDelay * 1000, 0, PowerUpDispencer_CreatePowerUp, %dispencer);
      }
   }
}

function PowerUpDispencer_CreatePowerUp(%this)
{
   if(!isObject(%this) || !$missionRunning || !$matchStarted)
	return;

   %logoHeight = %this.logoHeight;
   if(!%logoHeight)
	%logoHeight = 5;
	
   %numPowerUps = 6;

   if(mFloor(GetRandom() * %numPowerUps) == 1)
   {
      %powerup = new StaticShape() {
	   dataBlock = "Invincibility_PowerUp";
	   position = VectorAdd(%this.position, "0 0 " @ %logoHeight);
	   rotation = %this.rotation;
	   scale = %this.scale;
           };
      MissionCleanup.add(%powerup);
      %this.currentPowerUp = "Invincibility";
      %this.currentPowerUpLink = %powerup.getId();
      %this.dispenceDelay = 0;
      messageAll('ServerMessage', '\c0Power Up Dispencer loaded with Invincibility Power Up!~wfx/misc/hunters_horde.wav');
      if($SMASH::PowerUpEcho)
         echo("Power Up Dispencer loaded with Invincibility Power Up.");
   }
   else if(mFloor(GetRandom() * %numPowerUps) == 2)
   {
      %powerup = new StaticShape() {
	   dataBlock = "Invisibility_PowerUp";
	   position = VectorAdd(%this.position, "0 0 " @ %logoHeight);
	   rotation = %this.rotation;
	   scale = %this.scale;
           };
      MissionCleanup.add(%powerup);
      %this.currentPowerUp = "Invisibility";
      %this.currentPowerUpLink = %powerup.getId();
      %this.dispenceDelay = 0;
      messageAll('ServerMessage', '\c0Power Up Dispencer loaded with Invisibility Power Up!~wfx/misc/hunters_horde.wav');
      if($SMASH::PowerUpEcho)
         echo("Power Up Dispencer loaded with Invisibility Power Up.");
   }
   else if(mFloor(GetRandom() * %numPowerUps) == 3)
   {
      %powerup = new StaticShape() {
	   dataBlock = "Haste_PowerUp";
	   position = VectorAdd(%this.position, "0 0 " @ %logoHeight);
	   rotation = %this.rotation;
	   scale = %this.scale;
           };
      MissionCleanup.add(%powerup);
      %this.currentPowerUp = "Haste";
      %this.currentPowerUpLink = %powerup.getId();
      %this.dispenceDelay = 0;
      messageAll('ServerMessage', '\c0Power Up Dispencer loaded with Haste Power Up!~wfx/misc/hunters_horde.wav');
      if($SMASH::PowerUpEcho)
         echo("Power Up Dispencer loaded with Haste Power Up.");
   }
   else if(mFloor(GetRandom() * %numPowerUps) == 4)
   {
      if(Game.numTeams > 1) // is there more than 1 team?
      {
         %powerup = new StaticShape() {
	      dataBlock = "TeamHeal_PowerUp";
	      position = VectorAdd(%this.position, "0 0 " @ %logoHeight);
	      rotation = %this.rotation;
	      scale = %this.scale;
              };
         MissionCleanup.add(%powerup);
         %this.currentPowerUp = "TeamHeal";
         %this.currentPowerUpLink = %powerup.getId();
         %this.dispenceDelay = 0;
         messageAll('ServerMessage', '\c0Power Up Dispencer loaded with Team Heal Power Up!~wfx/misc/hunters_horde.wav');
         if($SMASH::PowerUpEcho)
            echo("Power Up Dispencer loaded with Team Heal Power Up.");
      }
      else // do haste
      {
         %powerup = new StaticShape() {
	      dataBlock = "Haste_PowerUp";
	      position = VectorAdd(%this.position, "0 0 " @ %logoHeight);
	      rotation = %this.rotation;
	      scale = %this.scale;
              };
         MissionCleanup.add(%powerup);
         %this.currentPowerUp = "Haste";
         %this.currentPowerUpLink = %powerup.getId();
         %this.dispenceDelay = 0;
         messageAll('ServerMessage', '\c0Power Up Dispencer loaded with Haste Power Up!~wfx/misc/hunters_horde.wav');
         if($SMASH::PowerUpEcho)
            echo("Power Up Dispencer loaded with Haste Power Up.");
      }
   }
   else if(mFloor(GetRandom() * %numPowerUps) == 5)
   {
      if(Game.numTeams > 1) // is there more than 1 team?
      {
         %powerup = new StaticShape() {
	      dataBlock = "Quake_PowerUp";
	      position = VectorAdd(%this.position, "0 0 " @ %logoHeight);
	      rotation = %this.rotation;
	      scale = %this.scale;
              };
         MissionCleanup.add(%powerup);
         %this.currentPowerUp = "TeamQuake";
         %this.currentPowerUpLink = %powerup.getId();
         %this.dispenceDelay = 0;
         messageAll('ServerMessage', '\c0Power Up Dispencer loaded with Team Quake Power Up!~wfx/misc/hunters_horde.wav');
         if($SMASH::PowerUpEcho)
            echo("Power Up Dispencer loaded with Team Quake Power Up.");
      }
      else
      {
         %powerup = new StaticShape() {
	      dataBlock = "Quake_PowerUp";
	      position = VectorAdd(%this.position, "0 0 " @ %logoHeight);
	      rotation = %this.rotation;
	      scale = %this.scale;
              };
         MissionCleanup.add(%powerup);
         %this.currentPowerUp = "Quake";
         %this.currentPowerUpLink = %powerup.getId();
         %this.dispenceDelay = 0;
         messageAll('ServerMessage', '\c0Power Up Dispencer loaded with Quake Power Up!~wfx/misc/hunters_horde.wav');
         if($SMASH::PowerUpEcho)
            echo("Power Up Dispencer loaded with Quake Power Up.");
      }
   }
   else
   {
      %powerup = new StaticShape() {
	   dataBlock = "Energy_PowerUp";
	   position = VectorAdd(%this.position, "0 0 " @ %logoHeight);
	   rotation = %this.rotation;
	   scale = %this.scale;
           };
      MissionCleanup.add(%powerup);
      %this.currentPowerUp = "Energy";
      %this.currentPowerUpLink = %powerup.getId();
      %this.dispenceDelay = 0;
      messageAll('ServerMessage', '\c0Power Up Dispencer loaded with Energy Power Up!~wfx/misc/hunters_horde.wav');
      if($SMASH::PowerUpEcho)
         echo("Power Up Dispencer loaded with Energy Power Up.");
   }
}

function PowerUpInvincibleActivate(%player)
{
   if(%player.getState() $= "Dead")
      return;

   if(!$SMASH::PowerUpInvincibleTime)
      $SMASH::PowerUpInvincibleTime = 20;

   if(isObject(%player.invincibilityPowerUpSchedule))
      cancel(%player.invincibilityPowerUpSchedule);

   messageAllExcept(%player.client, -1, 'ServerMessage', '\c0%1 got the Invincibility Power Up!~wfx/misc/red_alert.wav', %player.client.name);
   messageClient(%player.client, 'ServerMessage', '\c0You got the Invincibility Power Up!~wfx/powered/inv_pad_on.wav');
   %player.setPowerUpInvincible(true);
   %player.invincibilityPowerUpSchedule = schedule($SMASH::PowerUpInvincibleTime * 1000, 0, PowerUpInvincibleDeactivate, %player);
   if($SMASH::PowerUpEcho)
      echo(%player.client.nameBase @ " \(CL: " @ %player.client @ " PL: " @ %player @ "\) got the Invincibility Power Up.");
}

function PowerUpInvincibleDeactivate(%player)
{
   if(isObject(%player.invincibilityPowerUpSchedule))
      cancel(%player.invincibilityPowerUpSchedule);

   if(%player.PowerUpInvincible)
   {
	messageAllExcept(%player.client, -1, 'ServerMessage', '\c0%1 lost the Invincibility Power Up!~wfx/vehicles/inventory_pad_appear.wav', %player.client.name);
	messageClient(%player.client, 'ServerMessage', '\c0You lost the Invincibility Power Up!~wfx/powered/inv_pad_off.wav');
	%player.setPowerUpInvincible(false);
	if($SMASH::PowerUpEcho)
	   echo(%player.client.nameBase @ " \(CL: " @ %player.client @ " PL: " @ %player @ "\) lost the Invincibility Power Up.");
   }
}

function PowerUpInvisibleActivate(%player)
{
   if(%player.getState() $= "Dead")
      return;

   if(!$SMASH::PowerUpInvisibleTime)
      $SMASH::PowerUpInvisibleTime = 20;

   if(isObject(%player.invisibilityPowerUpSchedule))
      cancel(%player.invisibilityPowerUpSchedule);

   messageAllExcept(%player.client, -1, 'ServerMessage', '\c0%1 got the Invisibility Power Up!~wfx/misc/red_alert.wav', %player.client.name);
   messageClient(%player.client, 'ServerMessage', '\c0You got the Invisibility Power Up!~wfx/powered/inv_pad_on.wav');
   %player.setCloaked(true);
   %player.PowerUpInvisible = 1;
   %player.invisibilityPowerUpSchedule = schedule($SMASH::PowerUpInvisibleTime * 1000, 0, PowerUpInvisibleDeactivate, %player);
   if($SMASH::PowerUpEcho)
      echo(%player.client.nameBase @ " \(CL: " @ %player.client @ " PL: " @ %player @ "\) got the Invisibility Power Up.");
}

function PowerUpInvisibleDeactivate(%player)
{
   if(isObject(%player.invisibilityPowerUpSchedule))
      cancel(%player.invisibilityPowerUpSchedule);

   if(%player.PowerUpInvisible)
   {
	messageAllExcept(%player.client, -1, 'ServerMessage', '\c0%1 lost the Invisibility Power Up!~wfx/vehicles/inventory_pad_appear.wav', %player.client.name);
	messageClient(%player.client, 'ServerMessage', '\c0You lost the Invisibility Power Up!~wfx/powered/inv_pad_off.wav');
	if(%player.reCloak !$= "")
	{   
	   Cancel(%player.reCloak);
	   %player.reCloak = "";
	}
	%player.setCloaked(false);
	%player.PowerUpInvisible = 0;
	if($SMASH::PowerUpEcho)
	   echo(%player.client.nameBase @ " \(CL: " @ %player.client @ " PL: " @ %player @ "\) lost the Invisibility Power Up.");
   }
}

function PowerUpHasteActivate(%player)
{
   if(%player.getState() $= "Dead")
      return;

   if(!$SMASH::PowerUpHasteTime)
	$SMASH::PowerUpHasteTime = 20;

   if(isObject(%player.hastePowerUpSchedule))
      cancel(%player.hastePowerUpSchedule);

   messageAllExcept(%player.client, -1, 'ServerMessage', '\c0%1 got the Haste Power Up!~wfx/misc/red_alert.wav', %player.client.name);
   messageClient(%player.client, 'ServerMessage', '\c0You got the Haste Power Up!~wfx/powered/inv_pad_on.wav');
   %damage = %player.getDamageLevel();
   %energy = %player.getEnergyLevel();
   %size = %player.getArmorSize();
   %player.setHasteArmor(%size);
   %player.setDamageLevel(%damage);
   %player.setEnergyLevel(%energy);
   %player.PowerUpHaste = 1;
   %player.hastePowerUpSchedule = schedule($SMASH::PowerUpHasteTime * 1000, 0, PowerUpHasteDeactivate, %player);
   if($SMASH::PowerUpEcho)
      echo(%player.client.nameBase @ " \(CL: " @ %player.client @ " PL: " @ %player @ "\) got the Haste Power Up.");
}

function PowerUpHasteDeactivate(%player)
{
   if(isObject(%player.hastePowerUpSchedule))
      cancel(%player.hastePowerUpSchedule);

   if(%player.PowerUpHaste)
   {
	messageAllExcept(%player.client, -1, 'ServerMessage', '\c0%1 lost the Haste Power Up!~wfx/vehicles/inventory_pad_appear.wav', %player.client.name);
	messageClient(%player.client, 'ServerMessage', '\c0You lost the Haste Power Up!~wfx/powered/inv_pad_off.wav');
	%player.PowerUpHaste = 0;
   	if (%player.getState() $= "Dead")
	   return;

	%damage = %player.getDamageLevel();
	%energy = %player.getEnergyLevel();
	%size = %player.getArmorSize();
	%player.setArmor(%size);
	%player.setDamageLevel(%damage);
	%player.setEnergyLevel(%energy);
	if($SMASH::PowerUpEcho)
	   echo(%player.client.nameBase @ " \(CL: " @ %player.client @ " PL: " @ %player @ "\) lost the Haste Power Up.");
   }
}

function PowerUpEnergyActivate(%player)
{
   if(%player.getState() $= "Dead")
      return;

   if(!$SMASH::PowerUpEnergyTime)
      $SMASH::PowerUpEnergyTime = 20;

   if(isObject(%player.energyPowerUpSchedule))
      cancel(%player.energyPowerUpSchedule);

   messageAllExcept(%player.client, -1, 'ServerMessage', '\c0%1 got the Energy Power Up!~wfx/misc/red_alert.wav', %player.client.name);
   messageClient(%player.client, 'ServerMessage', '\c0You got the Energy Power Up!~wfx/powered/inv_pad_on.wav');
   %player.setRechargeRate(%player.getRechargeRate() * 1000);
   %player.PowerUpEnergy = 1;
   %player.energyPowerUpSchedule = schedule($SMASH::PowerUpEnergyTime * 1000, 0, PowerUpEnergyDeactivate, %player);
   if($SMASH::PowerUpEcho)
      echo(%player.client.nameBase @ " \(CL: " @ %player.client @ " PL: " @ %player @ "\) got the Energy Power Up.");
}

function PowerUpEnergyDeactivate(%player)
{
   if(isObject(%player.energyPowerUpSchedule))
      cancel(%player.energyPowerUpSchedule);

   if(%player.PowerUpEnergy)
   {
	messageAllExcept(%player.client, -1, 'ServerMessage', '\c0%1 lost the Energy Power Up!~wfx/vehicles/inventory_pad_appear.wav', %player.client.name);
	messageClient(%player.client, 'ServerMessage', '\c0You lost the Energy Power Up!~wfx/powered/inv_pad_off.wav');
	%player.setRechargeRate(%player.getRechargeRate() / 1000);
	%player.PowerUpEnergy = 0;
	if($SMASH::PowerUpEcho)
	   echo(%player.client.nameBase @ " \(CL: " @ %player.client @ " PL: " @ %player @ "\) lost the Energy Power Up.");
   }
}

function PowerUpTeamHealActivate(%player) // this powerup has no deactivation... its a "one-shot" powerup
{
   messageAllExcept(%player.client, -1, 'ServerMessage', '\c0%1 got the Team Heal Power Up for Team %2!~wfx/misc/red_alert.wav', %player.client.name, Game.getTeamName(%player.client.team));
   messageClient(%player.client, 'ServerMessage', '\c0You got the Team Heal Power Up!~wfx/powered/inv_pad_on.wav');
   for(%i = 0; %i < ClientGroup.getCount(); %i++)
   {
      %cl = ClientGroup.getObject(%i);
      %pl = %cl.player;
      // make sure the player is valid (client is not an observer) and on the
      // same team as the "powerup grabber's"
      if(%pl && %cl.team == %player.client.team)
      {
         if(%pl.getState() $= "Dead") return; // if they're dead, bad luck...
         %pl.applyRepair(1000.0); // make sure the player is totally healed from this
         if(%cl != %player.client) messageClient(%cl, '', '~wfx/powered/inv_pad_on.wav'); // dont play the sound twice for the "powerup grabber"
      }
   }
   if($SMASH::PowerUpEcho)
      echo(%player.client.nameBase @ " \(CL: " @ %player.client @ " PL: " @ %player @ " TM: " @ %player.client.team @ "\) got the Team Heal Power Up.");
}

datablock AudioProfile(SMASHQuakeSound)
{
   filename    = "fx/weapons/spinfusor_impact_UW.wav";
   description = AudioClose3d;
   preload = true;
};

function Player::applyQuake(%this, %velocity)
{
   // this function is ANOTHER morph of my getRandomDir() function in SMASHBounds.cs
   if(mFloor(GetRandom() * 2) == 1)
   {
	%x = GetRandom() * 1 * %velocity;
   }
   else
   {
	%x = GetRandom() * -1 * %velocity;
   }
   if(mFloor(GetRandom() * 2) == 1)
   {
	%y = GetRandom() * 1 * %velocity;
   }
   else
   {
	%y = GetRandom() * -1 * %velocity;
   }
   if(mFloor(GetRandom() * 2) == 1)
   {
	%z = GetRandom() * 1 * %velocity;
   }
   else
   {
	%z = GetRandom() * -1 * %velocity;
   }
   %randomVel = %x SPC %y SPC %z;
   %this.applyImpulse(%this.position, %randomVel);
   %this.playAudio(0, SMASHQuakeSound);
}

function PowerUpQuakeActivate(%player) // this powerup has no deactivation... its a "one-shot" powerup
{
   if(Game.numTeams > 1)
   {
      messageAllExcept(%player.client, -1, 'ServerMessage', '\c0%1 got the Team Quake Power Up for Team %2!~wfx/misc/red_alert.wav', %player.client.name, Game.getTeamName(%player.client.team));
      messageClient(%player.client, 'ServerMessage', '\c0You got the Team Quake Power Up!~wfx/powered/inv_pad_on.wav');
      for(%i = 0; %i < ClientGroup.getCount(); %i++)
      {
         %cl = ClientGroup.getObject(%i);
         %pl = %cl.player;
         // make sure the player is valid (client is not an observer) and on the
         // opposite team as the "powerup grabber's"
         if(%pl && %cl.team != %player.client.team)
         {
            if(%pl.getState() $= "Dead") return;
            %pl.applyQuake(1000 + (GetRandom() * 4000));
         }
      }
      if($SMASH::PowerUpEcho)
         echo(%player.client.nameBase @ " \(CL: " @ %player.client @ " PL: " @ %player @ " TM: " @ %player.client.team @ "\) got the Team Quake Power Up.");
   }
   else
   {
      messageAllExcept(%player.client, -1, 'ServerMessage', '\c0%1 got the Quake Power Up for Team %2!~wfx/misc/red_alert.wav', %player.client.name, Game.getTeamName(%player.client.team));
      messageClient(%player.client, 'ServerMessage', '\c0You got the Quake Power Up!~wfx/powered/inv_pad_on.wav');
      for(%i = 0; %i < ClientGroup.getCount(); %i++)
      {
         %cl = ClientGroup.getObject(%i);
         %pl = %cl.player;
         // make sure the player is valid (client is not an observer) and not the
         // "powerup grabber"
         if(%pl && %cl != %player.client)
         {
            if(%pl.getState() $= "Dead") return;
            %pl.applyQuake(1000 + (GetRandom() * 4000));
         }
      }
      if($SMASH::PowerUpEcho)
         echo(%player.client.nameBase @ " \(CL: " @ %player.client @ " PL: " @ %player @ " TM: " @ %player.client.team @ "\) got the Quake Power Up.");
   }
}

function Player::getCurrentPowerUp(%this)
{
   if(%this.PowerUpInvincible)
   {
	return "Invincibility";
   }
   else if(%this.PowerUpInvisible)
   {
	return "Invisibility";
   }
   else if(%this.PowerUpHaste)
   {
	return "Haste";
   }
   else if(%this.PowerUpEnergy)
   {
	return "Energy";
   }
   else
   {
	return "Unknown";
   }
}

function PowerUpDispencer::onAdd(%data, %obj)
{
   if(!%obj.logoHeight)
      %obj.logoHeight = "5";
}

function PowerUpDispencer::onCollision(%this, %obj, %colObj)
{
   if(!$matchStarted || !%colObj.client || %colObj.getState() $= "Dead")
	return;

   if(!$SMASH::PowerUps)
   {
	messageClient(%colObj.client, '', '\c2Access Denied -- Power Ups Disabled by Server.~wfx/powered/station_denied.wav');
	return;
   }

   if(%colObj.PowerUpInvincible || %colObj.PowerUpInvisible || %colObj.PowerUpHaste || %colObj.PowerUpEnergy)
   {
	messageClient(%colObj.client, '', '\c2Access Denied -- You currently have %1 Power Up activated, %2.~wfx/powered/station_denied.wav', %colObj.getCurrentPowerUp(), %colObj.client.name);
	return;
   }

   if(!$SMASH::PowerUpRefreshDelay)
	$SMASH::PowerUpRefreshDelay = 60;

   if(!%obj.initiated) // Power Up Dispencers are AUTOMATIC now... this is here just in case.
   {
	messageAllExcept(%colObj.client, -1, 'ServerMessage', '\c0%1 initialized the Power Up Dispencer.~wfx/misc/switch_taken.wav', %colObj.client.name);
	messageClient(%colObj.client, 'ServerMessage', '\c0You initialize the Power Up Dispencer.~wfx/misc/switch_taken.wav');
	%obj.dispenceDelay = 1;
        %obj.initiated = 1;
	Game.PowerUpRefresh = schedule($SMASH::PowerUpRefreshDelay * 1000, 0, PowerUpDispencer_CreatePowerUp, %obj);
	if($SMASH::PowerUpEcho)
	   echo(%colObj.client.nameBase @ " \(CL: " @ %colObj.client @ " PL: " @ %colObj @ "\) initialize the Power Up Dispencer.");

	return;
   }

   if(%obj.dispenceDelay && !%obj.currentPowerUp)
   {
	messageClient(%colObj.client, '', '\c2Access Denied -- Power Up Dispencer Recalculating... Wait Until Notified.~wfx/powered/station_denied.wav');
	return;
   }

   // Passed all checks, time to hand out the PowerUp!
   if(%obj.currentPowerUp $= "Invincibility")
   {
        PowerUpInvincibleActivate(%colobj);
   }
   else if(%obj.currentPowerUp $= "Invisibility")
   {
        PowerUpInvisibleActivate(%colobj);
   }
   else if(%obj.currentPowerUp $= "Haste")
   {
        PowerUpHasteActivate(%colobj);
   }
   else if(%obj.currentPowerUp $= "Energy")
   {
        PowerUpEnergyActivate(%colobj);
   }
   else if(%obj.currentPowerUp $= "TeamHeal")
   {
        PowerUpTeamHealActivate(%colobj);
   }
   else if(%obj.currentPowerUp $= "Quake" || %obj.currentPowerUp $= "TeamQuake")
   {
        PowerUpQuakeActivate(%colobj);
   }

   // Do the effect.
   SMASHPowerUpEffect(%colobj);

   // Proceed with variable changes.
   %link = %obj.currentPowerUpLink;
   %link.startFade(3000, 0, true);
   %link.schedule(3000, delete);
   Game.PowerUpRefresh = schedule($SMASH::PowerUpRefreshDelay * 1000, 0, PowerUpDispencer_CreatePowerUp, %obj);
   %obj.currentPowerUp = "";
   %obj.dispenceDelay = 1;
}