//------------------------------------------
// FLUDD - Watercannon from Mario Sunshine.
// Mario Sunshine and FLUDD  2002 Nintendo
//------------------------------------------


datablock AudioProfile(FLUDDWaterImpactSound)
{
   filename    = "fx/armor/general_water_smallsplash2.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(FLUDDProjectileSound)
{
   filename    = "fx/armor/light_RF_uw.wav";
   description = ProjectileLooping3d;
   preload = true;
};

datablock AudioProfile(FLUDDFireSound)
{
   filename    = "fx/armor/light_RF_bubbles.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(FLUDDReloadSound)
{
   filename    = "fx/armor/heavy_RF_uw.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock ParticleData(FLUDDWaterBubbles)
{
   dragCoefficient      = 1.0;
   gravityCoefficient   = 0.5;
   inheritedVelFactor   = 0.0;
   constantAcceleration = -1.1;
   lifetimeMS           = 1000;
   lifetimeVarianceMS   = 100;
   useInvAlpha          = false;
   spinRandomMin        = -90.0;
   spinRandomMax        = 500.0;
   textureName          = "special/bubbles";
   colors[0]     = "0.6 0.6 1.0 0.5";
   colors[1]     = "0.6 0.6 1.0 0.5";
   colors[2]     = "0.6 0.6 1.0 0.0";
   sizes[0]      = 1.0;
   sizes[1]      = 0.5;
   sizes[2]      = 0.1;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(FLUDDWaterBubblesEmitter)
{
   ejectionPeriodMS = 15;
   periodVarianceMS = 0;
   ejectionVelocity = 8.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 70;
   thetaMax         = 70;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   lifetimeMS       = 250;
   particles = "FLUDDWaterBubbles";
};


datablock ParticleData(FLUDDExplosionSmoke)
{
   dragCoeffiecient     = 0.4;
   gravityCoefficient   = 0.5;
   inheritedVelFactor   = 0.025;
   constantAcceleration = -1.1;

   lifetimeMS           = 1250;
   lifetimeVarianceMS   = 0;

   textureName          = "particleTest";

   useInvAlpha =  false;
   spinRandomMin = -200.0;
   spinRandomMax =  200.0;

   colors[0]     = "0.1 0.1 1.0 1.0";
   colors[1]     = "0.4 0.4 1.0 1.0";
   colors[2]     = "0.8 0.8 1.0 0.0";
   sizes[0]      = 1.0;
   sizes[1]      = 0.5;
   sizes[2]      = 0.1;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;

};

datablock ParticleEmitterData(FLUDDExplosionSmokeEmitter)
{
   ejectionPeriodMS = 15;
   periodVarianceMS = 0;

   ejectionVelocity = 4.25;
   velocityVariance = 0.25;

   thetaMin         = 0.0;
   thetaMax         = 90.0;

   lifetimeMS       = 250;

   particles = "FLUDDExplosionSmoke";
};

datablock ExplosionData(FLUDDExplosion)
{
   soundProfile   = FLUDDWaterImpactSound;

   faceViewer           = true;
   explosionScale = "0.1 0.1 0.1";

   emitter[0] = FLUDDWaterBubblesEmitter;
   emitter[1] = FLUDDExplosionSmokeEmitter;
   
   shakeCamera = true;
   camShakeFreq = "10.0 6.0 9.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 5.0;
};

//--------------------------------------------------------------------------
// Projectile
//--------------------------------------

datablock EnergyProjectileData(FLUDDWater)
{
   emitterDelay        = -1;
   directDamage        = 0.01;
   directDamageType    = $DamageType::FLUDDCannon;
   kickBackStrength    = 200;
   bubbleEmitTime      = 1.0;

   sound = FLUDDProjectileSound;
   velInheritFactor    = 1.0;

   explosion           = "FLUDDExplosion";
   splash              = BlasterSplash;


   grenadeElasticity = 0.1;
   grenadeFriction   = 0.9;
   armingDelayMS     = 250;

   muzzleVelocity    = 75.0;

   drag = 0.1;

   gravityMod        = 5;

   dryVelocity       = 100.0;
   wetVelocity       = 100.0;

   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = -1;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0.0 0.0 0.0";

   scale = "0.25 20.0 1.0";
   crossViewAng = 0.99;
   crossSize = 0.55;

   lifetimeMS     = -1;
   blurLifetime   = 0.0;
   blurWidth      = 0.0;
   blurColor = "0.0 0.0 0.0 1.0";

   texture[0] = "special/bubbles";
   texture[1] = "special/bubbles";
};

datablock EnergyProjectileData(FLUDDWaterMedium) : FLUDDWater
{
   directDamage        = 0.005;
   kickBackStrength    = 250
;

   explosion           = "FLUDDExplosion";

   muzzleVelocity    = 75.0;

   dryVelocity       = 75.0;
   wetVelocity       = 75.0;

   scale = "0.25 15.0 1.0";
   crossViewAng = 0.99;
   crossSize = 0.55;
};

datablock EnergyProjectileData(FLUDDWaterLow) : FLUDDWater
{
   directDamage        = 0.0025;
   kickBackStrength    = 100;

   explosion           = "FLUDDExplosion";

   muzzleVelocity    = 50.0;

   dryVelocity       = 50.0;
   wetVelocity       = 50.0;

   scale = "0.25 10.0 1.0";
   crossViewAng = 0.99;
   crossSize = 0.55;
};

//--------------------------------------------------------------------------
// Ammo
//--------------------------------------

datablock ItemData(FLUDDCannonAmmo)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "mortar_projectile.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "some FLUDD cannon ammo";

   computeCRC = true;
   emap = true;
};

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ShapeBaseImageData(FLUDDCannonFrontItemImage)
{
   className = WeaponImage;
   shapeFile = "weapon_mortar.dts";
   offset = "-0.03 0.8 -0.025";
   rotation = "1 0 1 180";
   emap = true;
};

datablock ShapeBaseImageData(FLUDDCannonNozzleItemImage)
{
   className = WeaponImage;
   shapeFile = "deploy_sensor_motion.dts";
   offset = "0 0.8 0.05";
   rotation = "1 0 0 180";
   emap = true;
};

datablock ItemData(FLUDDCannon)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_grenade_launcher.dts";
   image = FLUDDCannonImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a FLUDD cannon";

   computeCRC = true;

};

datablock ShapeBaseImageData(FLUDDCannonImage)
{
   className = WeaponImage;
   shapeFile = "weapon_grenade_launcher.dts";
   item = FLUDDCannon;
   ammo = FLUDDCannonAmmo;
   offset = "0 0 0";
   emap = true;

   projectileSpread = 2.5 / 1000.0;

   projectile = FLUDDWater;
   projectileType = EnergyProjectile;

   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activate";
   stateSound[0] = GrenadeSwitchSound;

   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "Ready";
   stateTransitionOnNoAmmo[1] = "NoAmmo";

   stateName[2] = "Ready";
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "Fire";

   stateName[3] = "Fire";
   stateTransitionOnTimeout[3] = "Ready";
   stateTimeoutValue[3] = 0.025;
   stateFire[3] = true;
   stateAllowImageChange[3] = false;
   stateSequence[3] = "Reload";
   stateScript[3] = "onFire";
   stateSound[3] = FLUDDFireSound;

   stateName[4] = "NoAmmo";
   stateTransitionOnAmmo[4] = "Ready";
   stateAllowImageChange[4] = false;
   stateRecoil[4] = LightRecoil;
   stateSequence[4] = "NoAmmo";
   stateScript[4] = "onNoAmmo";
   stateTransitionOnTriggerDown[4] = "DryFire";

   stateName[5]       = "DryFire";
   stateSound[5]      = GrenadeDryFireSound;
   stateAllowImageChange[5] = false;
   stateTimeoutValue[5]        = 1.0;
   stateTransitionOnTimeout[5] = "NoAmmo";
};

datablock ShapeBaseImageData(FLUDDCannonFrontImage)
{
   className = WeaponImage;
   shapeFile = "weapon_mortar.dts";
   offset = "-0.03 1.2 0.07";
   rotation = "1 0 1 180";
   emap = true;
};

datablock ShapeBaseImageData(FLUDDCannonNozzleImage)
{
   className = WeaponImage;
   shapeFile = "deploy_sensor_motion.dts";
   offset = "0 1.2 0.15";
   rotation = "1 0 0 180";
   emap = true;
};

function Player::checkFLUDDCannonRefillAmmo(%player)
{
   cancel(%player.checkFLUDDCannonRefillAmmoSchedule); // Don't want two schedule threads going.
   if(%player.getMountedImage($WeaponSlot).item $= "FLUDDCannon" && !%player.getImageTrigger($WeaponSlot)) 
   {
      %player.FLUDDCannonRefillAmmo();
   }
   else if(%player.getMountedImage($WeaponSlot).item !$= "FLUDDCannon")
   {
      %player.FLUDDCannonRefillAmmo();
   }
}

function Player::FLUDDCannonRefillAmmo(%player)
{
   cancel(%player.FLUDDCannonRefillAmmoSchedule); // Don't want two schedule threads going.
   // We need to stop the refill if the player's ammo is at max or the player is firing.
   if((%player.inv["FLUDDCannonAmmo"] >= 100) || (%player.getMountedImage($WeaponSlot).item $= "FLUDDCannon" && %player.getImageTrigger($WeaponSlot))) return;

   // If the player is in water then we refill faster... cuz its a water gun!
   if(%player.inWater)
   {
      %player.incInventory(FLUDDCannonAmmo,10);
   }
   else
   {
      %player.incInventory(FLUDDCannonAmmo,1);
   }
   %player.FLUDDCannonRefillAmmoSchedule = %player.schedule(100, FLUDDCannonRefillAmmo);
}

function FLUDDCannon::onAdd(%this, %obj)
{
   // Mount the item images so the gun actually looks like the one a player holds.
   %obj.mountImage("FLUDDCannonFrontItemImage", $ExtraSlotOne);
   %obj.mountImage("FLUDDCannonNozzleItemImage", $ExtraSlotTwo);
}

function FLUDDCannon::onThrow(%data,%obj,%player)
{
   // Cancel everything, we dont want the player to gain ammo when its not even
   // in the player's inventory.
   cancel(%player.FLUDDCannonRefillAmmoSchedule); // Don't want two schedule threads going.
   cancel(%player.checkFLUDDCannonRefillAmmoSchedule); // Don't want two schedule threads going.
   Parent::onThrow(%data,%obj,%player);
}

function FLUDDCannonImage::onNoAmmo(%data, %obj, %slot)
{
   %obj.checkFLUDDCannonRefillAmmo();
}

function FLUDDCannonImage::onFire(%data, %obj, %slot)
{
   %data.lightStart = getSimTime();

   if( %obj.station $= "" && %obj.isCloaked() && !%obj.PowerUpInvisible )
   {
      if( %obj.respawnCloakThread !$= "" )
      {
         Cancel(%obj.respawnCloakThread);
         %obj.setCloaked( false );
         %obj.respawnCloakThread = "";
      }
      else
      {
         if( %obj.getEnergyLevel() > 20 )
         {   
            %obj.setCloaked( false );
            %obj.reCloak = %obj.schedule( 500, "setCloaked", true ); 
         }
      }   
   }

   if( %obj.client > 0 )
   {   
      %obj.setInvincibleMode(0 ,0.00);
      %obj.setInvincible( false ); // fire your weapon and your invincibility goes away.   
   }
   
   %vehicle = 0;
   if(%obj.inv[%data.ammo] >= 75)
   {
      %vector = %obj.getMuzzleVector(%slot);
      %x = (getRandom() - 0.5) * 2 * 3.1415926 * (%data.projectileSpread / 2);
      %y = (getRandom() - 0.5) * 2 * 3.1415926 * (%data.projectileSpread / 2);
      %z = (getRandom() - 0.5) * 2 * 3.1415926 * (%data.projectileSpread / 2);
      %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
      %vector = MatrixMulVector(%mat, %vector);

      %p = new (%data.projectileType)() {
         dataBlock        = %data.projectile;
         initialDirection = %vector;
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
         vehicleObject    = %vehicle;
      };
   }
   else if(%obj.inv[%data.ammo] <= 75 && %obj.inv[%data.ammo] > 50)
   {
      %vector = %obj.getMuzzleVector(%slot);
      %x = (getRandom() - 0.5) * 2 * 3.1415926 * %data.projectileSpread;
      %y = (getRandom() - 0.5) * 2 * 3.1415926 * %data.projectileSpread;
      %z = (getRandom() - 0.5) * 2 * 3.1415926 * %data.projectileSpread;
      %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
      %vector = MatrixMulVector(%mat, %vector);

      %p = new (%data.projectileType)() {
         dataBlock        = %data.projectile;
         initialDirection = %vector;
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
         vehicleObject    = %vehicle;
      };
   }
   else if(%obj.inv[%data.ammo] <= 50 && %obj.inv[%data.ammo] > 25)
   {
      %vector = %obj.getMuzzleVector(%slot);
      %x = (getRandom() - 0.5) * 2 * 3.1415926 * (%data.projectileSpread * 4);
      %y = (getRandom() - 0.5) * 2 * 3.1415926 * (%data.projectileSpread * 4);
      %z = (getRandom() - 0.5) * 2 * 3.1415926 * (%data.projectileSpread * 4);
      %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
      %vector = MatrixMulVector(%mat, %vector);

      %p = new (%data.projectileType)() {
         dataBlock        = %data.projectile;
         initialDirection = %vector;
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
         vehicleObject    = %vehicle;
      };
   }
   else if(%obj.inv[%data.ammo] <= 25 && %obj.inv[%data.ammo] > 15)
   {
      %vector = %obj.getMuzzleVector(%slot);
      %x = (getRandom() - 0.5) * 2 * 3.1415926 * (%data.projectileSpread * 15);
      %y = (getRandom() - 0.5) * 2 * 3.1415926 * (%data.projectileSpread * 15);
      %z = (getRandom() - 0.5) * 2 * 3.1415926 * (%data.projectileSpread * 15);
      %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
      %vector = MatrixMulVector(%mat, %vector);

      %p = new (%data.projectileType)() {
         dataBlock        = %data.projectile @ "Medium";
         initialDirection = %vector;
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
         vehicleObject    = %vehicle;
      };
   }
   else if(%obj.inv[%data.ammo] <= 15)
   {
      %vector = %obj.getMuzzleVector(%slot);
      %x = (getRandom() - 0.5) * 2 * 3.1415926 * (%data.projectileSpread * 30);
      %y = (getRandom() - 0.5) * 2 * 3.1415926 * (%data.projectileSpread * 30);
      %z = (getRandom() - 0.5) * 2 * 3.1415926 * (%data.projectileSpread * 30);
      %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
      %vector = MatrixMulVector(%mat, %vector);

      %p = new (%data.projectileType)() {
         dataBlock        = %data.projectile @ "Low";
         initialDirection = %vector;
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
         vehicleObject    = %vehicle;
      };
   }

   if (isObject(%obj.lastProjectile) && %obj.deleteLastProjectile)
      %obj.lastProjectile.delete();

   %obj.lastProjectile = %p;
   %obj.deleteLastProjectile = %data.deleteLastProjectile;
   MissionCleanup.add(%p);
   
   // AI hook
   if(%obj.client)
      %obj.client.projectile = %p;

   %obj.decInventory(%data.ammo,1);
   cancel(%player.FLUDDCannonRefillAmmoSchedule); // Don't want two schedule threads going.
   cancel(%player.checkFLUDDCannonRefillAmmoSchedule); // Don't want two schedule threads going.
   %obj.checkFLUDDCannonRefillAmmoSchedule = %obj.schedule(200, checkFLUDDCannonRefillAmmo);
   return %p;
}

function FLUDDCannonImage::onMount(%this,%obj,%slot)
{
   cancel(%player.FLUDDCannonRefillAmmoSchedule); // Don't want two schedule threads going.
   cancel(%player.checkFLUDDCannonRefillAmmoSchedule); // Don't want two schedule threads going.
   %obj.FLUDDCannonRefillAmmo(); // Check for refill
   %obj.mountImage("FLUDDCannonFrontImage", $ExtraSlotOne);
   %obj.mountImage("FLUDDCannonNozzleImage", $ExtraSlotTwo);
   Parent::onMount(%this, %obj, %slot);
   // Set the reticle... stupid T2. :P
   %obj.client.setWeaponsHudActive("Mortar");
   %obj.client.setWeaponsHudActive(%this.item);
}

function FLUDDCannonImage::onUnmount(%this,%obj,%slot)
{
   %obj.unmountImage($ExtraSlotOne);
   %obj.unmountImage($ExtraSlotTwo);
   Parent::onUnmount(%this, %obj, %slot);
   // Set the reticle... stupid T2. :P
   %obj.client.setWeaponsHudActive("Mortar", 1);
   %obj.client.setWeaponsHudActive(%this.item, 1);
}