datablock LinearFlareProjectileData(UberBoom)
{
   doDynamicClientHits = true;

   directDamage        = 0;
   directDamageType    = $DamageType::Explosion;
   hasDamageRadius     = true;
   indirectDamage      = 1.0;
   damageRadius        = 20.0;
   kickBackStrength    = 7500;
   radiusDamageType    = $DamageType::Explosion;
   explosion           = "MortarExplosion";
   underwaterExplosion = "UnderwaterMortarExplosion";

   dryVelocity       = 500.0;
   wetVelocity       = 500.0;
   velInheritFactor  = 0.0;
   fizzleTimeMS      = 4000;
   lifetimeMS        = 6000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 4000;

   activateDelayMS = -1;

   scale             = "0.5 0.5 0.5";
   numFlares         = 30;
   flareColor        = "0.1 1.0 0.1";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "special/lensflare/flare00";//"flarebase";
};

datablock ItemData(UberGun)
{
   className    = Weapon;
   catagory     = "Spawn Items";
   shapeFile    = "weapon_targeting.dts";
   image        = UberGunImage;
   mass         = 1;
   elasticity   = 0.2;
   friction     = 0.6;
   pickupRadius = 2;
	pickUpName = "a uber gun";

   computeCRC = false;

};

datablock ShapeBaseImageData(UberGunImage)
{
   className = WeaponImage;

   shapeFile = "weapon_targeting.dts";
   item = UberGun;
   offset = "0 0 0";
   offset = "0 0 0";

   projectile = UberBoom;
   projectileType = LinearFlareProjectile;
   projectileSpread = 20.0 / 1000.0;
   deleteLastProjectile = false;

	usesEnergy = true;
	minEnergy = 0;

   stateName[0]                     = "Activate";
   stateSequence[0]                 = "Activate";
	stateSound[0]                    = TargetingLaserSwitchSound;
   stateTimeoutValue[0]             = 0.5;
   stateTransitionOnTimeout[0]      = "ActivateReady";

   stateName[1]                     = "ActivateReady";
   stateTransitionOnAmmo[1]         = "Ready";
   stateTransitionOnNoAmmo[1]       = "NoAmmo";

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "Fire";

   stateName[3]                     = "Fire";
	stateEnergyDrain[3]              = 0;
   stateFire[3]                     = true;
   stateAllowImageChange[3]         = false;
   stateScript[3]                   = "onFire";
   stateTransitionOnTriggerUp[3]    = "Deconstruction";
   stateTransitionOnNoAmmo[3]       = "Deconstruction";
   stateSound[3]                    = TargetingLaserPaintSound;

   stateName[4]                     = "NoAmmo";
   stateTransitionOnAmmo[4]         = "Ready";

   stateName[5]                     = "Deconstruction";
   stateScript[5]                   = "deconstruct";
   stateTransitionOnTimeout[5]      = "Ready";
};

function UberGun::onUse(%data, %obj)
{
   Weapon::onUse(%data, %obj);
   %obj.setArmThread(lookms);
}

function UberGun::onCollision(%data,%obj,%col)
{
   // do nothing (we don't want the ubergun to be picked up)
}

function UberGunImage::onFire(%data, %obj, %slot)
{
   for(%i = 0; %i < 4 + mFloor(GetRandom() * 6); %i++)
   {
      %vector = %obj.getMuzzleVector(%slot);
      %x = (getRandom() - 0.5) * 2 * 3.1415926 * %data.projectileSpread;
      %y = (getRandom() - 0.5) * 2 * 3.1415926 * %data.projectileSpread;
      %z = (getRandom() - 0.5) * 2 * 3.1415926 * %data.projectileSpread;
      %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
      %vector = MatrixMulVector(%mat, %vector);

      %p = new (%data.projectileType)() {
         dataBlock        = %data.projectile;
         initialDirection = %vector;
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
         vehicleObject    = %vehicle;
      };

      if (isObject(%obj.lastProjectile) && %obj.deleteLastProjectile)
         %obj.lastProjectile.delete();

      %obj.lastProjectile = %p;
      %obj.deleteLastProjectile = %data.deleteLastProjectile;
      MissionCleanup.add(%p);
   }
   serverPlay3D(SniperRifleProjectileSound, %obj.getMuzzlePoint(%slot));
}

function UberGunImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this, %obj, %slot);
   // Set the reticle... stupid T2. :P
   %obj.client.setWeaponsHudActive("TargetingLaser");
   %obj.client.setWeaponsHudActive(%this.item);
}

function UberGunImage::onUnmount(%this,%obj,%slot)
{
   Parent::onUnmount(%this, %obj, %slot);
   // Set the reticle... stupid T2. :P
   %obj.client.setWeaponsHudActive("TargetingLaser", 1);
   %obj.client.setWeaponsHudActive(%this.item, 1);
}